package org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Health;

import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.Panel;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Timer;
import java.util.TimerTask;

import javax.swing.JButton;
import javax.swing.JPanel;

import org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention.Prevention;
import org.eclipse.linuxtools.lttng.SYSPRO.AlertOptimization.AlertOptimization;
import org.eclipse.linuxtools.lttng.SYSPRO.Connection.Provider;
import org.eclipse.linuxtools.lttng.SYSPRO.Connection.Requester;
import org.eclipse.linuxtools.lttng.SYSPRO.Prediction.Prediction;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.RiskAssessment;
import org.eclipse.linuxtools.lttng.SYSPRO.ui.Connect;
import org.eclipse.swt.SWT;
import org.eclipse.swt.awt.SWT_AWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.ui.part.ViewPart;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.data.time.Millisecond;
import org.jfree.data.time.TimeSeries;
import org.jfree.data.time.TimeSeriesCollection;
import org.jfree.ui.RefineryUtilities;
import org.swtchart.Chart;
import org.swtchart.IAxis;
import org.swtchart.IAxisSet;
import org.swtchart.ILineSeries;
import org.swtchart.ILineSeries.PlotSymbolType;
import org.swtchart.ISeries.SeriesType;
import org.swtchart.LineStyle;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Timer;
import java.util.TimerTask;

import javax.swing.JButton;
import javax.swing.JPanel;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartFrame;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.ValueAxis;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.data.time.Millisecond;
import org.jfree.data.time.TimeSeries;
import org.jfree.data.time.TimeSeriesCollection;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;
import org.jfree.ui.ApplicationFrame;
import org.jfree.ui.RefineryUtilities;



public class HealthView extends ViewPart {

	public static final String ID = "org.eclipse.ui.tutorials.rcp.part3.HealthView";
	Connect c = new Connect();
	ResultSet rs = null;
	RiskAssessment risk_assessment = new RiskAssessment();
	AlertOptimization alert_optimization = new AlertOptimization();
	Prediction prediction = new Prediction();
	Prevention prevention = new Prevention();
	int MaxId = 0;
	int flag = 0;
	// chart parameter
	private static final long serialVersionUID = 1L;

	// The time series data
	private TimeSeries series;
	private TimeSeries series_AO;
	private TimeSeries series_P;
	
	// Response series
	XYSeries xyseries1 = new XYSeries("Logout", true, false);
	XYSeries xyseries2 = new XYSeries("Reset", true, false);
	XYSeries xyseries3 = new XYSeries("Shutdown", true, false);
	XYSeries xyseries4 = new XYSeries("LockUser", true, false);
	XYSeries xyseries5 = new XYSeries("RemoveUser", true, false);
	XYSeries xyseries6 = new XYSeries("KillProcess", true, false);
	XYSeries xyseries7 = new XYSeries("RemoveAllUser", true, false);

	public void createPartControl(Composite parent) {
		Composite top = new Composite(parent, SWT.NONE);
		GridLayout layout = new GridLayout();
		layout.marginHeight = 5;
		layout.marginWidth = 10;
		top.setLayout(layout);

		//  Get information from Detection component
		final Composite banner = new Composite(top, SWT.NONE);
		banner.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL, GridData.VERTICAL_ALIGN_BEGINNING, true, false));
		layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		layout.numColumns = 2;
		banner.setLayout(layout);

		// for chart
		final Composite banner_chart_AO = new Composite(top, SWT.NONE);
		banner_chart_AO.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, true));

		final Composite banner_chart = new Composite(top, SWT.NONE);
		banner_chart.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, true));

		final Composite banner_chart_P = new Composite(top, SWT.NONE);
		banner_chart_P.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, true));
		
		final Composite banner_chart_R = new Composite(top, SWT.NONE);
		banner_chart_R.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, true));

		// Set Dynamic Chart for Alert Optimization
		this.series_AO = new TimeSeries("Optimized Severity", Millisecond.class);
		final TimeSeriesCollection dataset_AO = new TimeSeriesCollection(this.series_AO);
		final JFreeChart chart_AO = createChart_AO(dataset_AO);
		Composite comp_AO = new Composite(banner_chart_AO, SWT.NONE | SWT.EMBEDDED);
		comp_AO.setSize(1200, 200);
		Frame frame_AO = SWT_AWT.new_Frame(comp_AO);

		ChartPanel chartPanel_AO = new ChartPanel(chart_AO);
		frame_AO.add(chartPanel_AO);

		// Set Dynamic Chart
		this.series = new TimeSeries("Risk Index", Millisecond.class);
		final TimeSeriesCollection dataset = new TimeSeriesCollection(this.series);
		final JFreeChart chart = createChart(dataset);
		Composite comp = new Composite(banner_chart, SWT.NONE | SWT.EMBEDDED);
		comp.setSize(1200, 200);
		Frame frame = SWT_AWT.new_Frame(comp);

		ChartPanel chartPanel = new ChartPanel(chart);
		frame.add(chartPanel);

		// Set Dynamic Chart for Prediction
		this.series_P = new TimeSeries("Compromized State", Millisecond.class);
		final TimeSeriesCollection dataset_P = new TimeSeriesCollection(this.series_P);
		final JFreeChart chart_P = createChart_P(dataset_P);
		Composite comp_P = new Composite(banner_chart_P, SWT.NONE | SWT.EMBEDDED);
		comp_P.setSize(1200, 200);
		Frame frame_P = SWT_AWT.new_Frame(comp_P);

		ChartPanel chartPanel_P = new ChartPanel(chart_P);
		frame_P.add(chartPanel_P);
		
		// // Set Dynamic Chart for Prevention
	    XYSeriesCollection dataset_R;
	    dataset_R = new XYSeriesCollection();
        dataset_R.addSeries(xyseries1);
        dataset_R.addSeries(xyseries2);
        dataset_R.addSeries(xyseries3);
        dataset_R.addSeries(xyseries4);
        dataset_R.addSeries(xyseries5);
        dataset_R.addSeries(xyseries6);
        dataset_R.addSeries(xyseries7);
        
        final JFreeChart chart_R = createChart_R(dataset_R);
		Composite comp_R = new Composite(banner_chart_R, SWT.NONE | SWT.EMBEDDED);
		comp_R.setSize(1200, 200);
		Frame frame_R = SWT_AWT.new_Frame(comp_R);

		ChartPanel chartPanel_R = new ChartPanel(chart_R);
		frame_R.add(chartPanel_R);

		// Read Database Continuously
		final long delay = 1000;   	// delay for 1 sec.
		final long interval = 1000;  	// iterate every sec.
		final Timer timer = new Timer();

		double riskValue = 0.0;

		final Thread SHMThread = new Thread("SHMThread") {
			public void run() {
				Provider server = new Provider();
				while(true){
					server.run();
				}
			}
		};

		final Thread detectionThread = new Thread("detectionThread") {
			public void run() {
				Requester client = new Requester();
				client.run();
			}
		};
		
		final Button button1 = new Button(banner, SWT.WRAP);
		button1.setText("Start Connect to Detection Component");
		button1.setLayoutData(new GridData(GridData.VERTICAL_ALIGN_BEGINNING));
		button1.addSelectionListener(new SelectionListener() {

			public void widgetSelected(SelectionEvent e) {
				if (button1.getText().contains("Stop Connect to Detection Component")) {
					button1.setText("Start Connect to Detection Component");
				} else {
//					Display display = Display.getDefault();
//					display.asyncExec(new Runnable() {
//						@Override
//						public void run() {
//							prevention.run(0.8, 0.95);
//						}
//					});
					//prevention.run(0.8, 0.95);
					SHMThread.start();
					button1.setText("Stop Connect to Detection Component");
					//set Date and Time
					final String start_date;
					final String start_time;

					start_date = now("yyyy-MM-dd");
					start_time = now("H:mm:ss");

					timer.scheduleAtFixedRate(new TimerTask() {
						public void run() {
							String now_date;
							String now_time;

							now_date = now("yyyy-MM-dd");
							now_time = now("H:mm:ss");
							readDatabase(start_date,start_time,now_date,now_time);
						}
					}, delay, interval);
				}
			}

			public void widgetDefaultSelected(SelectionEvent e) {

			}
		});

		/*Button btn_send = new Button(banner, SWT.WRAP);
		btn_send.setText("Send");
		btn_send.setLayoutData(new GridData(GridData.VERTICAL_ALIGN_BEGINNING));
		btn_send.addSelectionListener(new SelectionListener() {

			public void widgetSelected(SelectionEvent e) {
				detectionThread.start();
			}

			public void widgetDefaultSelected(SelectionEvent e) {

			}
		});*/
		
		/*Button btn_send1 = new Button(banner, SWT.WRAP);
		btn_send1.setText("Test");
		btn_send1.setLayoutData(new GridData(GridData.VERTICAL_ALIGN_BEGINNING));
		btn_send1.addSelectionListener(new SelectionListener() {

			public void widgetSelected(SelectionEvent e) {
				double riskResult;
				riskResult = risk_assessment.run(6, 3, 2, 3.02, 1, 100);
				riskResult = risk_assessment.run(6, 3, 2, 3.02, 1, 100);
				riskResult = risk_assessment.run(6, 3, 2, 3.02, 1, 100);
				riskResult = risk_assessment.run(6, 3, 2, 3.02, 1, 100);
				riskResult = risk_assessment.run(6, 3, 2, 3.02, 1, 100);
				riskResult = risk_assessment.run(6, 3, 2, 3.02, 1, 100);
				riskResult = risk_assessment.run(6, 3, 2, 3.02, 1, 100);

			}

			public void widgetDefaultSelected(SelectionEvent e) {

			}
		});*/

	}

	private void readDatabase(String start_date, String start_time, String now_date, String now_time) {

		rs = null;
		double riskResult = 0.0;
		double optimizedResult = 0.0;
		double[] HMMStateResult = new double[4];


		try {
			rs = c.Query("Select Alert.Id, Alert.DetectDate, Alert.DetectTime, Alert.Confidence, Alert.SourceIP, Alert.DestinationIP, Alert.ProcessId, Alert.UserName, Alert.FilePath, AlertClassification.Severity, AlertClassification.Id as 'AlertClassificationId', Alert_Resource.ResourceId, ResourceValueLevel.Value as 'ResourceValue', VulnerabilityEffectLevel.Value as 'VulnerabilityValue', AlertClassification.Name " +
					"from Alert, AlertClassification, ResourceValueLevel, Alert_Resource, VulnerabilityEffectLevel " +
					"where Alert.AlertClassificationId= AlertClassification.Id " +
					"and AlertClassification.Id= Alert_Resource.AlertClassificationId " +
					"and Alert_Resource.ResourceId = ResourceValueLevel.Resource_Id " +
					"and ResourceValueLevel.Resource_Id = VulnerabilityEffectLevel.Resource_Id " +
					"and  Alert.Id > " + MaxId + " " +
					"and  DetectDate >= '" + start_date + "' " +
					"and  DetectTime >= '" + start_time + "' " +
					"and  DetectDate <= '" + now_date + "' " +
					"and  DetectTime <= '" + now_time + "' " +
			"ORDER BY DetectDate, DetectTime, Alert.Id ASC LIMIT 1");

		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				MaxId = Integer.parseInt(rs.getString ("Alert.Id"));
				String SourceIP = rs.getString ("Alert.SourceIP");
				String DestinationIP = rs.getString ("Alert.DestinationIP");
				int ProcessId = Integer.parseInt(rs.getString ("Alert.ProcessId"));
				String UserName = rs.getString ("Alert.UserName");
				String FilePath = rs.getString ("Alert.FilePath");


				// Offline values
				double resourceValueVal = Double.parseDouble(rs.getString ("ResourceValue"));
				double vulnerabilityValueVal = Double.parseDouble(rs.getString ("VulnerabilityValue"));
				// Online values
				
				String detectDateVal = rs.getString ("DetectDate"); 
				String detectTimeVal = rs.getString ("DetectTime");
				System.out.println(detectTimeVal);
				double confidenceVal = Double.parseDouble(rs.getString ("Confidence"));

				int severityVal = 0;

				if (rs.getString ("Severity").toString().contains("Low")) {
					severityVal = 1;
				} 
				if (rs.getString ("Severity").contains("Medium")) {
					severityVal = 2;
				} 
				if (rs.getString ("Severity").contains("High")) {
					severityVal = 3;
				}

				int alertClassificationIdVal = Integer.parseInt(rs.getString ("AlertClassificationId"));
				int resourceIdVal = Integer.parseInt(rs.getString ("ResourceId"));

				optimizedResult = alert_optimization.run(alertClassificationIdVal);


				int severityTorisk;
				
				if (optimizedResult >= 4)
				{
					HMMStateResult = prediction.run(4);
					severityTorisk= 4;
				}
				else if (optimizedResult >= 3) 
				{
					HMMStateResult = prediction.run(3);
					severityTorisk= 3;
				}
				else if (optimizedResult >= 2)
				{
					HMMStateResult = prediction.run(2);
					severityTorisk= 2;
				}
				else
				{
					HMMStateResult = prediction.run(1);
					severityTorisk= 1;
				}

				//riskResult = risk_assessment.run(resourceIdVal, severityVal, resourceValueVal, vulnerabilityValueVal, alertClassificationIdVal, confidenceVal);
				riskResult = risk_assessment.run(resourceIdVal, severityTorisk, resourceValueVal, vulnerabilityValueVal, alertClassificationIdVal, confidenceVal);
				prevention.run(DestinationIP, ProcessId, UserName, FilePath, riskResult, confidenceVal, HMMStateResult[3]);
				if (flag == 0) {
					updateChartResponse(2);
					flag = 1;
				} 
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}

		updateChart(riskResult, optimizedResult, HMMStateResult[3]);

	}

	private JFreeChart createChart(final XYDataset dataset) {
		final JFreeChart result = ChartFactory.createTimeSeriesChart(
				"Online Risk Assessment", 
				"Time", 
				"Value",
				dataset, 
				true, 
				true, 
				false
		);
		final XYPlot plot = result.getXYPlot();
		ValueAxis axis = plot.getDomainAxis();
		axis.setAutoRange(true);
		axis.setFixedAutoRange(360000.0);  // 60 seconds
		axis = plot.getRangeAxis();
		axis.setRange(-0.1, 1.0); 
		return result;
	}

	private JFreeChart createChart_AO(final XYDataset dataset) {
		final JFreeChart result = ChartFactory.createTimeSeriesChart(
				"Online Alert Optimization", 
				"Time", 
				"Value",
				dataset, 
				true, 
				true, 
				false
		);
		final XYPlot plot = result.getXYPlot();
		ValueAxis axis = plot.getDomainAxis();
		axis.setAutoRange(true);
		axis.setFixedAutoRange(360000.0);  // 60 seconds
		axis = plot.getRangeAxis();
		axis.setRange(-0.1, 4.0); 
		return result;
	}

	private JFreeChart createChart_P(final XYDataset dataset) {
		final JFreeChart result = ChartFactory.createTimeSeriesChart(
				"Online Prediction", 
				"Time", 
				"Value",
				dataset, 
				true, 
				true, 
				false
		);
		final XYPlot plot = result.getXYPlot();
		ValueAxis axis = plot.getDomainAxis();
		axis.setAutoRange(true);
		axis.setFixedAutoRange(360000.0);  // 60 seconds
		axis = plot.getRangeAxis();
		axis.setRange(-0.1, 1.0); 
		return result;
	}
	
	private JFreeChart createChart_R(final XYDataset dataset) {
        final JFreeChart chart = ChartFactory.createScatterPlot(
            "Prevention",                  // chart title
            "Machine No.",        // x axis label
            "Response No.",                // y axis label
            dataset,                  // data
            PlotOrientation.VERTICAL,
            true,                     // include legend
            true,                     // tooltips
            false                     // urls
        );
        XYPlot plot = (XYPlot) chart.getPlot();
        XYLineAndShapeRenderer renderer = new XYLineAndShapeRenderer();
        renderer.setSeriesLinesVisible(0, true);
        plot.setRenderer(renderer);
        return chart;
    }

	public void updateChart(double riskResult, double optimizedResult, double HMMStateResult) {
		final Millisecond now = new Millisecond();
		//System.out.println("Now = " + now.toString());
		//this.series.add(new Millisecond(), riskResult);
		//this.series_AO.add(new Millisecond(), optimizedResult);
		this.series.add(now, riskResult);
		this.series_AO.add(now, optimizedResult);
		this.series_P.add(now, HMMStateResult);

	}
	
	public void updateChartResponse(int Id) {
		
		if ( Id==1 ) {
	  		 //xyseries1.add(1, 1);
		} else if ( Id==2 ) {
	  		 //xyseries2.add(1, 1);
		}
		
	}

	public static String now(String dateFormat) {
		Calendar cal = Calendar.getInstance();
		SimpleDateFormat sdf = new SimpleDateFormat(dateFormat);
		return sdf.format(cal.getTime());

	}


	public void setFocus() {
	}
}
