package org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;

import org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention.Strategy;
import org.eclipse.tm.tcf.core.AbstractPeer;
import org.eclipse.tm.tcf.protocol.IChannel;
import org.eclipse.tm.tcf.protocol.IEventQueue;
import org.eclipse.tm.tcf.protocol.IPeer;
import org.eclipse.tm.tcf.protocol.Protocol;

import java.util.*;
import java.io.*;

public class Prevention {
	
	double RISK_THRESHOLD;
	double PREDICTION_THRESHOLD;

		
	public Prevention () {
		RISK_THRESHOLD = 80;
		PREDICTION_THRESHOLD = 90;
	}

	private static class EventQueue extends Thread implements IEventQueue {

        private final LinkedList<Runnable> queue = new LinkedList<Runnable>();

        EventQueue() {
            setName("TCF Event Dispatcher");
            start();
        }

        public void run() {
            try {
                while (true) {
                    Runnable r = null;
                    synchronized (this) {
                        while (queue.isEmpty()) wait();
                        r = queue.removeFirst();
                    }
                    r.run();
                }
            }
            catch (Throwable x) {
                x.printStackTrace();
                System.exit(1);
            }
        }

        public synchronized int getCongestion() {
            int n = queue.size() - 100;
            if (n > 100) n = 100;
            return n;
        }

        public synchronized void invokeLater(Runnable runnable) {
            queue.add(runnable);
            notify();
        }

        public boolean isDispatchThread() {
            return Thread.currentThread() == this;
        }
    }

    private static class RemotePeer extends AbstractPeer {

        private final ArrayList<Map<String,String>> attrs;

        public RemotePeer(ArrayList<Map<String,String>> attrs) {
            super(attrs.get(0));
            this.attrs = attrs;
        }

        public IChannel openChannel() {
            assert Protocol.isDispatchThread();
            IChannel c = super.openChannel();
            for (int i = 1; i < attrs.size(); i++) c.redirect(attrs.get(i));
            return c;
        }
    }

    private static IPeer getPeer(String[] arr) {
        ArrayList<Map<String,String>> l = new ArrayList<Map<String,String>>();
        for (String s : arr) {
            Map<String,String> map = new HashMap<String,String>();
            int len = s.length();
            int i = 0;
            while (i < len) {
                int i0 = i;
                while (i < len && s.charAt(i) != '=' && s.charAt(i) != 0) i++;
                int i1 = i;
                if (i < len && s.charAt(i) == '=') i++;
                int i2 = i;
                while (i < len && s.charAt(i) != ':') i++;
                int i3 = i;
                if (i < len && s.charAt(i) == ':') i++;
                String key = s.substring(i0, i1);
                String val = s.substring(i2, i3);
                map.put(key, val);
            }
            l.add(map);
        }
        String id = l.get(0).get(IPeer.ATTR_ID);
        if (id == null) throw new Error("Invalid peer info: no ID");
        IPeer peer = Protocol.getLocator().getPeers().get(id);
        if (peer != null) throw new Error("Invalid peer info: ID is not unique");
        return new RemotePeer(l);
    }

    private static void runReactiveMeasures(IPeer peer) {
    	try {
        	Strategy strategy = new Strategy();
        	strategy.MAXConfidentiality();
        	strategy.runStrategy(peer);
    	}
    	catch (Throwable x) {
    		System.err.println("Cannot start startegy:");
    		x.printStackTrace();
    		System.exit(2);
    	}
    }

    
	public void run(String DestinationIP, int ProcessId, String UserName, String FilePath, double riskIndex, double confidenceVal, double compromizeIndex) {
		final String[] args = new String [1];
				
//		/** "ID=Test:TransportName=TCP:Host=172.16.28.133:Port=1534"; **/
//		args[0] = "ID=Test:TransportName=TCP:Host=" + DestinationIP + ":Port=1534";
//		
//		if (confidenceVal * riskIndex >= RISK_THRESHOLD) {
//			System.out.println("Prevention: risk (" + confidenceVal * riskIndex + ") is high for " + DestinationIP );
//			Protocol.setEventQueue(new EventQueue());
//	        Protocol.invokeLater(new Runnable() {
//	            public void run() {
//	            	runReactiveMeasures(getPeer(args));
//	            }
//	        });
//	        Protocol.invokeLater(10 * 60 * 1000, new Runnable() {
//	            public void run() {
//	                System.err.println("Error: timeout - prevention's not finished in 10 min");
//	                System.exit(5);
//	            }
//	        });
//		}
//		
//		if (compromizeIndex >= PREDICTION_THRESHOLD) {
//			System.out.println("Prevention: a multi-step attack is going to be happened in a near future with " + compromizeIndex + " Probability");
//		}
	}
}
