package org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention.Response;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.tm.tcf.protocol.IChannel;
import org.eclipse.tm.tcf.protocol.IToken;
import org.eclipse.tm.tcf.services.IProcesses;
import org.eclipse.tm.tcf.services.IProcesses.ProcessContext;

/**
 * Minimum number of days allowed between password 
 * Change this parameter PASS_MIN_DAYS in this file /etc/login.defs
 */

public class RMMinDaysBetweenPassChange implements IReactiveMeasures {
	static public String Name = "PLAN_MIN_DAYS_BETWEEN_PASS_CHANGE";
	static public int Id = 12;
	static public double Risk_threshold = 0.6;
    
    private final IProcesses  processes;

    public RMMinDaysBetweenPassChange(IChannel channel) {
            
        processes = channel.getRemoteService(IProcesses.class);
         
    }
    		
	private String[] toArgsArray(String file, String cmd) {
        // Create arguments list from a command line.
        int i = 0;
        int l = cmd.length();
        List<String> arr = new ArrayList<String>();
        arr.add(file);
        for (;;) {
            while (i < l && cmd.charAt(i) == ' ') i++;
            if (i >= l) break;
            String s = null;
            if (cmd.charAt(i) == '"') {
                i++;
                StringBuffer bf = new StringBuffer();
                while (i < l) {
                    char ch = cmd.charAt(i++);
                    if (ch == '"') break;
                    if (ch == '\\' && i < l) ch = cmd.charAt(i++);
                    bf.append(ch);
                }
                s = bf.toString();
            }
            else {
                int i0 = i;
                while (i < l && cmd.charAt(i) != ' ') i++;
                s = cmd.substring(i0, i);
            }
            arr.add(s);
        }
        return arr.toArray(new String[arr.size()]);
	}

	@Override
	public void start() {
		// TODO Auto-generated method stub
		final String dir = "/home/";
		final String file = "/bin/sed";
	    final String args = "-i \"s/PASS_MIN_DAYS[\t| ]*[0-9]+/PASS_MIN_DAYS 541/\" /etc/login.defs";
	    
	    processes.start(dir, file, toArgsArray(file, args), null , false, new IProcesses.DoneStart() {      	  
				public void doneStart(IToken token, Exception error, ProcessContext process) {
					System.out.println(error.toString());
				}		
			});
		System.out.println(Name + " with " + Risk_threshold + " threshold was run");
		
	}
	
}
