package org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention.Response;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.tm.tcf.protocol.IChannel;
import org.eclipse.tm.tcf.protocol.IToken;
import org.eclipse.tm.tcf.services.IFileSystem;
import org.eclipse.tm.tcf.services.IProcesses;
import org.eclipse.tm.tcf.services.IFileSystem.FileSystemException;
import org.eclipse.tm.tcf.services.IFileSystem.IFileHandle;
import org.eclipse.tm.tcf.services.IProcesses.ProcessContext;

/**
 * This Reactive Measure will that IP forwarding be turned off
 * To make the change PERMANENT add the following line to /etc/sysctl.conf:
 * net.ipv4.ip_forward=0
 */

public class RMPerDeactiveIpForwarding implements IReactiveMeasures {
	static public String Name = "RM_PERMANENT_DEACTIVATE_IP_FORWARDING";
	static public int Id = 27;
	static public double Risk_threshold = 0.6;
    
    private final IProcesses processes;


    public RMPerDeactiveIpForwarding(IChannel channel) {
            
    	processes = channel.getRemoteService(IProcesses.class);

    }
    
	@Override
	public void start() {
		
		removePattern();

		
	}
	
	private String[] toArgsArray(String file, String cmd) {
        // Create arguments list from a command line.
        int i = 0;
        int l = cmd.length();
        List<String> arr = new ArrayList<String>();
        arr.add(file);
        for (;;) {
            while (i < l && cmd.charAt(i) == ' ') i++;
            if (i >= l) break;
            String s = null;
            if (cmd.charAt(i) == '"') {
                i++;
                StringBuffer bf = new StringBuffer();
                while (i < l) {
                    char ch = cmd.charAt(i++);
                    if (ch == '"') break;
                    if (ch == '\\' && i < l) ch = cmd.charAt(i++);
                    bf.append(ch);
                }
                s = bf.toString();
            }
            else {
                int i0 = i;
                while (i < l && cmd.charAt(i) != ' ') i++;
                s = cmd.substring(i0, i);
            }
            arr.add(s);
        }
        return arr.toArray(new String[arr.size()]);
	}
	
	private void removePattern() {
		
	}
	
}
