package org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention.Response;

import org.eclipse.tm.tcf.protocol.IChannel;
import org.eclipse.tm.tcf.protocol.IToken;
import org.eclipse.tm.tcf.services.IFileSystem;
import org.eclipse.tm.tcf.services.IFileSystem.FileSystemException;
import org.eclipse.tm.tcf.services.IFileSystem.IFileHandle;

/**
 * This Reactive Measure will cause the kernel does not accept ICMP redirect packets.
 * ICMP redirects can be used to alter your routing tables, possibly to a malicious end.
 * To make the change PERMANENT add the following line to /etc/sysctl.conf:
 * net.ipv4.conf.all.accept_redirects = 0
 */

public class RMPerDisableRedirectAcceptance implements IReactiveMeasures {
	static public String Name = "RM_PERMANENT_DISABLE_REDIRECT_ACCEPTANCE";
	static public int Id = 30;
	static public double Risk_threshold = 0.6;
    
    private final IFileSystem files;
    private IFileHandle filehandle;



    public RMPerDisableRedirectAcceptance(IChannel channel) {
            
    	files = channel.getRemoteService(IFileSystem.class);

    }
    
	@Override
	public void start() {
		
		
	}
	
}
