package org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention.Response;

import org.eclipse.tm.tcf.protocol.IChannel;
import org.eclipse.tm.tcf.protocol.IToken;
import org.eclipse.tm.tcf.services.IFileSystem;
import org.eclipse.tm.tcf.services.IFileSystem.FileSystemException;
import org.eclipse.tm.tcf.services.IFileSystem.IFileHandle;

/**
 * This Reactive Measure will cause that kernel does not accept source routed packets.
 * Attackers can use source routing to generate traffic pretending to originate from 
 * inside your network, but that is actually routed back along the path from which it
 * came, so attackers can compromise your network. Source routing is rarely used 
 * for legitimate purposes, so it is safe to disable it.
 * To make the change PERMANENT add the following line to /etc/sysctl.conf:
 * net.ipv4.conf.all.accept_source_route = 0
 */

public class RMPerDisableSourceRoutedPackets implements IReactiveMeasures {
	static public String Name = "RM_PERMANENT_DISABLE_SOURCE_ROUTED_PACKETS";
	static public int Id = 29;
	static public double Risk_threshold = 0.6;
    
    private final IFileSystem files;
    private IFileHandle filehandle;



    public RMPerDisableSourceRoutedPackets(IChannel channel) {
            
    	files = channel.getRemoteService(IFileSystem.class);

    }
    
	@Override
	public void start() {
		
	}
	
}
