package org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention.Response;

import org.eclipse.tm.tcf.protocol.IChannel;
import org.eclipse.tm.tcf.protocol.IToken;
import org.eclipse.tm.tcf.services.IFileSystem;
import org.eclipse.tm.tcf.services.IFileSystem.FileSystemException;
import org.eclipse.tm.tcf.services.IFileSystem.IFileHandle;

/**
 * This Reactive Measure turns on reverse path filtering.
 * This helps make sure that packets use legitimate source addresses
 * by automatically rejecting incoming packets if the routing table entry for their source address
 * does not match the network interface they are arriving on. This has security advantages because 
 * it prevents IP spoofing. We need to reenable it for each net/ipv4/conf/* otherwise source validation 
 * isn't fully functional
 * for i in /proc/sys/net/ipv4/conf/*; do
 *     net.ipv4.conf.$i.rp_filter=1
 * done
 */

public class RMPerEnableReversePathFiltering implements IReactiveMeasures {
	static public String Name = "RM_PERMANENT_ENABLE_REVERSE_PATH_FILTERING";
	static public int Id = 32;
	static public double Risk_threshold = 0.6;
    
    private final IFileSystem files;
    private IFileHandle filehandle;



    public RMPerEnableReversePathFiltering(IChannel channel) {
            
    	files = channel.getRemoteService(IFileSystem.class);

    }
    
	@Override
	public void start() {
		
	}
	
}
