package org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention.Response;

import org.eclipse.tm.tcf.protocol.IChannel;
import org.eclipse.tm.tcf.protocol.IToken;
import org.eclipse.tm.tcf.services.IFileSystem;
import org.eclipse.tm.tcf.services.IFileSystem.FileSystemException;
import org.eclipse.tm.tcf.services.IFileSystem.IFileHandle;

/**
 * This Reactive Measure will disable response to ICMP broadcasts and prevent Smurf attacks. 
 * The Smurf attack works by sending an ICMP type 0 (ping) message to the broadcast address of a network. 
 * Typically the attacker will use a spoofed source address. All the computers on the network will respond 
 * to the ping message and thereby flood the host at the spoofed source address
 * To make the change PERMANENT add the following line to /etc/sysctl.conf:
 * net.ipv4.icmp_echo_ignore_broadcasts=1
 */

public class RMPerIgnoreBroadcastPings implements IReactiveMeasures {
	static public String Name = "RM_PERMANENT_IGNORE_BROADCAST_PINGS";
	static public int Id = 28;
	static public double Risk_threshold = 0.6;
    
    private final IFileSystem files;
    private IFileHandle filehandle;



    public RMPerIgnoreBroadcastPings(IChannel channel) {
            
    	files = channel.getRemoteService(IFileSystem.class);

    }
    
	@Override
	public void start() {
		
	}
	
}
