package org.eclipse.linuxtools.lttng.SYSPRO.AlertOptimization;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.eclipse.linuxtools.lttng.SYSPRO.ui.Connect;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.ui.part.ViewPart;


public class AlertClassificationView extends ViewPart {

	public static final String ID = "org.eclipse.ui.tutorials.rcp.part3.AlertClassificationView";

	public void createPartControl(Composite parent) {
		Composite top = new Composite(parent, SWT.NONE);
		GridLayout layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		top.setLayout(layout);
		// top banner
		Composite banner = new Composite(top, SWT.NONE);
		banner.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL, GridData.VERTICAL_ALIGN_BEGINNING, true, false));
		layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		layout.numColumns = 2;
		banner.setLayout(layout);

		// Create Toolbar
	    Image insert_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/insert_object.png");
	    Image edit_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/edit_object.png");
	    Image delete_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/delete_object.png");

	    
		ToolBar toolBar = new ToolBar (banner, SWT.FLAT | SWT.BORDER);
		ToolItem itemInsert = new ToolItem (toolBar, SWT.DROP_DOWN | SWT.PUSH);
		//itemInsert.setText("Insert");
		itemInsert.setImage(insert_icon);
		itemInsert.setToolTipText("Insert");
		ToolItem itemUpdate = new ToolItem (toolBar, SWT.PUSH);
		//itemUpdate.setText("Update");
		itemUpdate.setImage(edit_icon);
		itemUpdate.setToolTipText("Edit");
		ToolItem itemDelete = new ToolItem (toolBar, SWT.PUSH);
		//itemDelete.setText("Delete");
		itemDelete.setImage(delete_icon);
		itemDelete.setToolTipText("Delete");


		toolBar.pack ();
		
		// Create table
		Table t = new Table(top, SWT.BORDER);
		
		
		TableColumn tc1 = new TableColumn(t, SWT.CENTER);
		TableColumn tc2 = new TableColumn(t, SWT.CENTER);
		TableColumn tc3 = new TableColumn(t, SWT.CENTER);
		TableColumn tc4 = new TableColumn(t, SWT.CENTER);

		tc1.setText("Id");
		tc2.setText("Name");
		tc3.setText("Acceptable");
		tc4.setText("Severity");

		tc1.setWidth(100);
		tc2.setWidth(300);
		tc3.setWidth(100);
		tc4.setWidth(100);

		t.setHeaderVisible(true);

		Connect c = new Connect();
	
		ResultSet rs = null;
		try {
			rs = c.Query("select * from AlertClassification ORDER BY Id");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String idVal = rs.getString ("Id");
				String nameVal = rs.getString ("Name");
				String acceptableVal = rs.getString ("Acceptable");
				String severityVal = rs.getString ("Severity");

			
				TableItem item1 = new TableItem(t, SWT.NONE);
				item1.setText(new String[] { idVal,nameVal,acceptableVal,severityVal});
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		t.pack();

	}

	public void setFocus() {
	}
}
