package org.eclipse.linuxtools.lttng.SYSPRO.AlertOptimization;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DecimalFormat;

import net.sourceforge.jFuzzyLogic.FIS;

import org.eclipse.core.runtime.Platform;
import org.eclipse.linuxtools.lttng.SYSPRO.ui.Application;
import org.eclipse.linuxtools.lttng.SYSPRO.ui.Connect;
import org.eclipse.ui.internal.util.BundleUtility;
import org.osgi.framework.Bundle;



public class AlertOptimization {
	
	Connect c = new Connect();
	ResultSet rs = null;
	double[] alertNumArray;
	double[] Priority;
	double[] AcceptableArray;
	double[] NormalizedArray;
	double totalAlert= 0;

	public AlertOptimization () {
			
		// Set Alert Number Array
		rs = null;
		int alertClassificationNO = -1;

		try {
			rs = c.Query("SELECT COUNT(*) FROM AlertClassification");
			rs.next();
			alertClassificationNO = rs.getInt(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}
				
		alertNumArray = new double[alertClassificationNO+1];
		Priority = new double[alertClassificationNO+1];
		AcceptableArray = new double[alertClassificationNO+1];
		NormalizedArray = new double[alertClassificationNO+1];


		for (int i=1; i <= alertClassificationNO; i++) {
			alertNumArray[i] = 0;
		}
		
		// Set Priority Matrix and Acceptable Array
		try {
			rs = c.Query("Select * from AlertClassification ORDER BY Id ASC");
			int i = 1;
			while (rs.next ())
			{
				
				int AcceptableVal = Integer.parseInt(rs.getString ("Acceptable"));
				double NormalizedValueVal = Double.parseDouble(rs.getString ("NormalizedValue"));

				AcceptableArray[i]= AcceptableVal;
				NormalizedArray[i]= NormalizedValueVal;

				if (rs.getString ("Severity").toString().contains("Low")) {
					Priority[i++] = 1;
				} 
				if (rs.getString ("Severity").contains("Medium")) {
					Priority[i++] = 2;
				} 
				if (rs.getString ("Severity").contains("High")) {
					Priority[i++] = 3;
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
 }

	public double run(int Alert_Index) {
		
		
		double N, F, K, A;

		F = NormalizedArray[Alert_Index];
		N = alertNumArray[Alert_Index];
		K = 1;
		A = AcceptableArray[Alert_Index];
		
		
		
		//Priority[Alert_Index] = Priority[Alert_Index] * java.lang.Math.pow(2.7,(N * alertNumArray[Alert_Index])
		//		/(k * AcceptableArray[Alert_Index]-N * alertNumArray[Alert_Index]));
		
		//Priority[Alert_Index] = Priority[Alert_Index] * java.lang.Math.pow(2.7,(N * alertNumArray[Alert_Index])
		//			/(1 * AcceptableArray[Alert_Index]));
			
		Priority[Alert_Index] = Priority[Alert_Index] * java.lang.Math.pow(1.7,(F * N)/(K * A));
		
		alertNumArray[Alert_Index]++;
		totalAlert++;
		
		if (Alert_Index == 9)
			//System.out.println("Alert Severity: " + Priority[Alert_Index] + " F:"+ F + " N:" + N + " A:"+ A);
			System.out.println(Priority[Alert_Index]);

		
		return Priority[Alert_Index];
	}
}
