package org.eclipse.linuxtools.lttng.SYSPRO.AlertOptimization;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import org.eclipse.linuxtools.lttng.SYSPRO.ui.Connect;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.part.ViewPart;
import org.swtchart.Chart;
import org.swtchart.IAxis;
import org.swtchart.IAxisSet;
import org.swtchart.ILineSeries;
import org.swtchart.ILineSeries.PlotSymbolType;
import org.swtchart.ISeries.SeriesType;
import org.swtchart.LineStyle;


public class MonitoringOfflineAlertOptimizationView extends ViewPart {

	public static final String ID = "org.eclipse.ui.tutorials.rcp.part3.MonitoringOfflineAlertOptimizationView";

	public void createPartControl(Composite parent) {
		Composite top = new Composite(parent, SWT.NONE);
		GridLayout layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		top.setLayout(layout);

		// banner
		Composite banner = new Composite(top, SWT.NONE);
		banner.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, true));
		banner.setSize(1500, 250);


		// Create chart for Raw Alert
		Chart chart = new Chart(banner, SWT.COLOR_CYAN);
		chart.setSize(1500, 250);
		chart.getTitle().setText("Severity of Raw Alert with Range={Low, Medium, High} for Onile Risk Assessment");
		chart.getAxisSet().getXAxis(0).getTitle().setText("Alert");
		chart.getAxisSet().getYAxis(0).getTitle().setText("Severity");

		IAxisSet axisSet = chart.getAxisSet();
		IAxis xAxis = axisSet.getXAxis(0);


		Connect c = new Connect();
		int counter = 0;

		ResultSet rs = null;

		int rowCount_Alert = -1;

		try {
			rs = c.Query("SELECT COUNT(*) FROM Alert");
			rs.next();
			rowCount_Alert = rs.getInt(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}

		String[] cateValues = new String[rowCount_Alert];
		double[] YValues = new double[rowCount_Alert];

		try {
			rs = c.Query("Select * from Alert, AlertClassification where Alert.AlertClassificationId= AlertClassification.Id ORDER BY DetectDate, DetectTime, Alert.Id ASC");

			while (rs.next ())
			{
				cateValues[counter] = Integer.toString(counter);
				if (rs.getString ("Severity").toString().contains("Low")) {
					YValues[counter++] = 1;
				} 
				if (rs.getString ("Severity").contains("Medium")) {
					YValues[counter++] = 2;
				} 
				if (rs.getString ("Severity").contains("High")) {
					YValues[counter++] = 3;
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}

		xAxis.setCategorySeries(cateValues);
		//xAxis.enableCategory(true);

		ILineSeries series = (ILineSeries) chart.getSeriesSet().createSeries(
				SeriesType.LINE, "Severity");
		series.setLineColor(parent.getDisplay().getSystemColor(SWT.COLOR_RED));
		series.setLineStyle(LineStyle.SOLID);
		series.setYSeries(YValues);
		IAxis yAxis = axisSet.getYAxis(0);
		yAxis.adjustRange();
		xAxis.adjustRange();

		yAxis.zoomIn();
		yAxis.zoomOut();
		series.setSymbolType(PlotSymbolType.NONE);	


		// banner
		Composite bannerOA = new Composite(top, SWT.NONE);
		bannerOA.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, true));
		bannerOA.setSize(1500, 300);

		counter = 0;

		// Create chart for Optimized Alert
		Chart chartOA = new Chart(bannerOA, SWT.COLOR_CYAN);
		chartOA.setSize(1500, 300);
		chartOA.getTitle().setText("Severity of Optimized Alert with Range={Low, Medium, High, Very High} for Prediction");
		chartOA.getAxisSet().getXAxis(0).getTitle().setText("Alert");
		chartOA.getAxisSet().getYAxis(0).getTitle().setText("Severity");

		IAxisSet axisSetOA = chartOA.getAxisSet();
		IAxis xAxisOA = axisSetOA.getXAxis(0);

		int rowCount_AlertClassification = -1;

		try {
			rs = c.Query("SELECT COUNT(*) FROM AlertClassification");
			rs.next();
			rowCount_AlertClassification = rs.getInt(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}

		String[] cateValuesOA = new String[rowCount_Alert];
		double[] YValuesOA = new double[rowCount_Alert];
		double[] Priority = new double[rowCount_AlertClassification];
		double[] Alert_Num = new double[rowCount_AlertClassification];
		//double[] Alert_Id_Mapping = new double[rowCount_AlertClassification];
		ArrayList Alert_Id_Mapping = new ArrayList();



		for (int i=0; i< rowCount_AlertClassification; i++) {
			Alert_Num[i] = 0;
		}

		// Set Priority Matrix
		try {
			rs = c.Query("Select * from AlertClassification ORDER BY Id ASC");
			int i = 0;
			while (rs.next ())
			{
				int Alert_Index = Integer.parseInt(rs.getString ("Id"));

				if (rs.getString ("Severity").toString().contains("Low")) {
					Priority[i++] = 1;
				} 
				if (rs.getString ("Severity").contains("Medium")) {
					Priority[i++] = 2;
				} 
				if (rs.getString ("Severity").contains("High")) {
					Priority[i++] = 3;
				}
				Alert_Id_Mapping.add(Alert_Index);

			}
		} catch (SQLException e) {
			e.printStackTrace();
		}

		// Calculate
		try {
			rs = c.Query("Select * from Alert, AlertClassification where Alert.AlertClassificationId= AlertClassification.Id ORDER BY DetectDate, DetectTime, Alert.Id ASC");

			while (rs.next ())
			{

				int Alert_Index = Integer.parseInt(rs.getString ("AlertClassificationId"));
				int AcceptableVal = Integer.parseInt(rs.getString ("Acceptable"));
				double NormalizedValueVal = Double.parseDouble(rs.getString ("NormalizedValue"));

				cateValuesOA[counter] = Integer.toString(counter);

				int index = Alert_Id_Mapping.indexOf(Alert_Index);

				if (Priority[index] <= 4)	{	
					Priority[index] = Priority[index] * java.lang.Math.pow(2.7,(NormalizedValueVal * Alert_Num[index])/(200 * AcceptableVal-NormalizedValueVal * Alert_Num[index]));
				}
				Alert_Num[index]++;
				YValuesOA[counter++] = Priority[index];
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}

		xAxisOA.setCategorySeries(cateValuesOA);
		//xAxis.enableCategory(true);

		ILineSeries seriesOA = (ILineSeries) chartOA.getSeriesSet().createSeries(
				SeriesType.LINE, "Severity");
		seriesOA.setLineColor(parent.getDisplay().getSystemColor(SWT.COLOR_RED));
		seriesOA.setLineStyle(LineStyle.SOLID);
		seriesOA.setYSeries(YValuesOA);
		IAxis yAxisOA = axisSetOA.getYAxis(0);
		yAxisOA.adjustRange();
		xAxisOA.adjustRange();

		yAxisOA.zoomIn();
		yAxisOA.zoomOut();
		seriesOA.setSymbolType(PlotSymbolType.NONE);

	}

	public void setFocus() {
	}
}
