package org.eclipse.linuxtools.lttng.SYSPRO.Connection;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Calendar;

import org.eclipse.linuxtools.lttng.SYSPRO.ui.Connect;
public class Provider{
	ServerSocket providerSocket;
	Socket connection = null;
	ObjectOutputStream out;
	ObjectInputStream in;
	public Provider(){}
	public void run()
	{
		String message = "";

		try{
			//1. creating a server socket
			providerSocket = new ServerSocket(2011, 1);
			//2. Wait for connection
			System.out.println("Waiting for connection");
			connection = providerSocket.accept();
			System.out.println("Connection received from " + connection.getInetAddress().getHostName());
			//3. get Input and Output streams
			out = new ObjectOutputStream(connection.getOutputStream());
			out.flush();
			in = new ObjectInputStream(connection.getInputStream());
			sendMessage("Connection successful");
			//4. The two parts communicate via the input and output streams
			do{
				try{
					message = (String)in.readObject();
					if (!message.equals("bye"))
						storeMessageinDB(message);
					System.out.println("client>" + message);
					if (message.equals("bye"))
						sendMessage("bye");

				}
				catch(ClassNotFoundException classnot){
					System.err.println("Data received in unknown format");
				}
			}while(!message.equals("bye"));
		}
		catch(IOException ioException){
			ioException.printStackTrace();
		}
		finally{
			//4: Closing connection
			try{
				in.close();
				out.close();
				providerSocket.close();
			}
			catch(IOException ioException){
				ioException.printStackTrace();
			}
		}
	}
	void sendMessage(String msg)
	{
		try{
			out.writeObject(msg);
			out.flush();
			//System.out.println("server>" + msg);
		}
		catch(IOException ioException){
			ioException.printStackTrace();
		}
	}
	void storeMessageinDB(String msg)
	{
		// import
		Connect c2 = new Connect();

		ResultSet rs = null;
		int AlertClassification;
		int Confidence;
		String SrcPortVal = "21";
		String SrcIPAddressVal = "132.207.72.12";
		String DestPortVal = "21";
		String DestIPAddressVal = "132.207.72.14";

		String Date1;
		String Time1;

		Connect c1 = new Connect();

		int frs_ch, snd_ch;

		//msg= "1;50;132.207.72.24;3128;132.207.72.25;80;2011-06-27;16:47:44;";
		
		frs_ch = msg.indexOf(";");
		AlertClassification = Integer.parseInt(msg.substring(0, frs_ch));
		
		msg = msg.replaceFirst(";", "*");
		snd_ch = msg.indexOf(";");
		Confidence = Integer.parseInt(msg.substring(frs_ch+1, snd_ch));

		frs_ch = snd_ch;
		msg = msg.replaceFirst(";", "*");
		snd_ch = msg.indexOf(";");
		SrcIPAddressVal = msg.substring(frs_ch+1, snd_ch);
		
		frs_ch = snd_ch;
		msg = msg.replaceFirst(";", "*");
		snd_ch = msg.indexOf(";");
		SrcPortVal = msg.substring(frs_ch+1, snd_ch);

		frs_ch = snd_ch;
		msg = msg.replaceFirst(";", "*");
		snd_ch = msg.indexOf(";");
		DestIPAddressVal = msg.substring(frs_ch+1, snd_ch);
		
		frs_ch = snd_ch;
		msg = msg.replaceFirst(";", "*");
		snd_ch = msg.indexOf(";");
		DestPortVal = msg.substring(frs_ch+1, snd_ch);
		
		frs_ch = snd_ch;
		msg = msg.replaceFirst(";", "*");
		snd_ch = msg.indexOf(";");
		Date1 = msg.substring(frs_ch+1, snd_ch);
		
		frs_ch = snd_ch;
		msg = msg.replaceFirst(";", "*");
		snd_ch = msg.indexOf(";");
		Time1 = msg.substring(frs_ch+1, snd_ch);
		
		
		try {
			c1.Insert("insert into Alert (Analyzer,DetectDate,DetectTime,AlertClassificationId,Confidence,SourceIp,SourcePort,DestinationIp,DestinationPort) " +
					"values ('naser','" + Date1 + "','" + Time1 + "'," + AlertClassification + "," + Confidence + ",'"+ SrcIPAddressVal+"',"+ SrcPortVal+",'"+ DestIPAddressVal +"'," + DestPortVal +")");
		} catch (SQLException e1) {
			e1.printStackTrace();
		}
	}

	public static String now(String dateFormat) {
		Calendar cal = Calendar.getInstance();
		SimpleDateFormat sdf = new SimpleDateFormat(dateFormat);
		return sdf.format(cal.getTime());
	}

}