package org.eclipse.linuxtools.lttng.SYSPRO.Prediction;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.eclipse.linuxtools.lttng.SYSPRO.AlertOptimization.AlertOptimization;
import org.eclipse.linuxtools.lttng.SYSPRO.ui.Connect;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.part.ViewPart;
import org.swtchart.Chart;
import org.swtchart.IAxis;
import org.swtchart.IAxisSet;
import org.swtchart.ILineSeries;
import org.swtchart.ILineSeries.PlotSymbolType;
import org.swtchart.ISeries.SeriesType;
import org.swtchart.LineStyle;


public class MonitoringOfflinePredictionOverTimeView extends ViewPart {

	public static final String ID = "org.eclipse.ui.tutorials.rcp.part3.MonitoringOfflinePredictionOverTimeView";
	public Connect c = new Connect();
	int[] AlertClassification;
	double[] AlertSeverity;
	String oldDetectTimeVal="";
	
	AlertOptimization alert_optimization = new AlertOptimization();

	DateFormat sdf = new SimpleDateFormat("hh:mm:ss");
	Date date;
	double starTime = 0;
	double setTime = 0;
	double preTime = 0;
	int timeFlag = 0;
	int MaxId = 0;// 2839;

	public void createPartControl(Composite parent) {
		Composite top = new Composite(parent, SWT.NONE);
		GridLayout layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		top.setLayout(layout);

		// banner
		Composite bannerN = new Composite(top, SWT.NONE);
		bannerN.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, true));
		bannerN.setSize(1500, 200);

		Composite bannerIA = new Composite(top, SWT.NONE);
		bannerIA.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, true));
		bannerIA.setSize(1500, 200);

		Composite bannerIP = new Composite(top, SWT.NONE);
		bannerIP.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, true));
		bannerIP.setSize(1500, 200);

		Composite bannerC = new Composite(top, SWT.NONE);
		bannerC.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, true));
		bannerC.setSize(1500, 200);

		// Chart for Normal State
		Chart chartN = new Chart(bannerN, SWT.COLOR_CYAN);
		chartN.setSize(1500, 200);
		chartN.getTitle().setText("Normal State");
		chartN.getAxisSet().getXAxis(0).getTitle().setText("Time(s)");
		chartN.getAxisSet().getYAxis(0).getTitle().setText("Probability");
		IAxisSet axisSetN = chartN.getAxisSet();
		IAxis xAxisN = axisSetN.getXAxis(0);
		// Chart for IA State
		Chart chartIA = new Chart(bannerIA, SWT.COLOR_CYAN);
		chartIA.setSize(1500, 200);
		chartIA.getTitle().setText("Attempt State");
		chartIA.getAxisSet().getXAxis(0).getTitle().setText("Time(s)");
		chartIA.getAxisSet().getYAxis(0).getTitle().setText("Probability");
		IAxisSet axisSetIA = chartIA.getAxisSet();
		IAxis xAxisIA = axisSetIA.getXAxis(0);
		// Chart for IP State
		Chart chartIP = new Chart(bannerIP, SWT.COLOR_CYAN);
		chartIP.setSize(1500, 200);
		chartIP.getTitle().setText("Progress State");
		chartIP.getAxisSet().getXAxis(0).getTitle().setText("Time(s)");
		chartIP.getAxisSet().getYAxis(0).getTitle().setText("Probability");
		IAxisSet axisSetIP = chartIP.getAxisSet();
		IAxis xAxisIP = axisSetIP.getXAxis(0);
		// Chart for C State
		Chart chartC = new Chart(bannerC, SWT.COLOR_CYAN);
		chartC.setSize(1500, 200);
		chartC.getTitle().setText("Compromise State");
		chartC.getAxisSet().getXAxis(0).getTitle().setText("Time(s)");
		chartC.getAxisSet().getYAxis(0).getTitle().setText("Probability");
		IAxisSet axisSetC= chartC.getAxisSet();
		IAxis xAxisC = axisSetC.getXAxis(0);


		ResultSet rs = null;

		int rowCount = -1;

		try {
			rs = c.Query("SELECT COUNT(*) FROM Alert");
			rs.next();
			rowCount = rs.getInt(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}


		String[] cateValuesN = new String[11634];
		double[] YValuesN = new double[11634];
		String[] cateValuesIA = new String[11634];
		double[] YValuesIA = new double[11634];
		String[] cateValuesIP = new String[11634];
		double[] YValuesIP= new double[11634];
		String[] cateValuesC = new String[11634];
		double[] YValuesC = new double[11634];
		
		/*rowCount= 10;
		String[] cateValuesN = new String[200];
		double[] YValuesN = new double[200];
		String[] cateValuesIA = new String[200];
		double[] YValuesIA = new double[200];
		String[] cateValuesIP = new String[200];
		double[] YValuesIP= new double[200];
		String[] cateValuesC = new String[200];
		double[] YValuesC = new double[200];*/
		
		// Set Alert Classification Array
		rs = null;
		int alertClassificationNO = -1;

		try {
			rs = c.Query("SELECT COUNT(*) FROM AlertClassification");
			rs.next();
			alertClassificationNO = rs.getInt(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		AlertClassification = new int[alertClassificationNO+1];
		AlertSeverity = new double[alertClassificationNO+1];
		
		for (int i=1; i <= alertClassificationNO; i++) {
			AlertClassification[i] = 0;
			AlertSeverity[i] = 0.0;
		}

		// Initialize 
		int i, j, ObsIndex, sendingIndex;
		double sum;
		double sumAlpha;
		int statesNb = 0;
		int observationsNb = 0;
		int predictionCount = 0;
		statesNb = ReadstatesNb();
		observationsNb = ReadObservationsNb();

		double[][] alpha = new double[rowCount][statesNb];
		double[][] gama = new double[rowCount][statesNb];
		double[][] transitionProbability = new double[statesNb][statesNb];
		double[][] emissionProbability = new double[statesNb][observationsNb];
		double[] startProbability = new double[statesNb];

		startProbability [0] = 1.0; 
		startProbability [1] = 0.0;
		startProbability [2] = 0.0;
		startProbability [3] = 0.0;

		for (i= 0; i < statesNb; i++) {	
			for (j= 0; j < statesNb; j++) {
				transitionProbability[i][j] = ReadTransitionValue(i+1,j+1);
			}
		}

		for (i= 0; i < statesNb; i++) {	
			for (j= 0; j < observationsNb; j++) {
				emissionProbability[i][j] = ReadEmissionValue(i+1,j+1);
			}
		}

		// Start Analysis
		System.out.println("\tStarting of Hidden Markov Model analysis...\n");
		
		sendingIndex = ReadObservations(0);
		sumAlpha = 0;
		for (i= 0; i < statesNb; i++) {	
			alpha[0][i]= startProbability[i] * emissionProbability[i][sendingIndex-1];
			sumAlpha += alpha[0][i];
		}

		for (i= 0; i < statesNb; i++) {	
			gama[0][i]= alpha[0][i]/sumAlpha;
			//System.out.println("\t" + gama[0][i]);
			for(double t= preTime; t < setTime; t++) {
				cateValuesN[(int) t] = Double.toString(t);
				YValuesN[(int) t] = 1;
				
				cateValuesIA[(int) t] = Double.toString(t);
				YValuesIA[(int) t] = 0;

				cateValuesIP[(int) t] = Double.toString(t);
				YValuesIP[(int) t] = 0;

				cateValuesC[(int) t] = Double.toString(t);
				YValuesC[(int) t] = 0;

			}
			cateValuesN[(int) setTime] = Double.toString(setTime);
			YValuesN[(int) setTime] = gama[0][0];
			
			cateValuesIA[(int) setTime] = Double.toString(setTime);
			YValuesIA[(int) setTime] = gama[0][1];

			cateValuesIP[(int) setTime] = Double.toString(setTime);
			YValuesIP[(int) setTime] = gama[0][2];

			cateValuesC[(int) setTime] = Double.toString(setTime);
			YValuesC[(int) setTime] = gama[0][3];
			
		}
		
		int flag= 0;
		for (ObsIndex = 1; ObsIndex < rowCount; ObsIndex++) {
			sumAlpha = 0;
			sum = 0;
			preTime = setTime;
			sendingIndex = ReadObservations(ObsIndex); 
			for (i= 0; i < statesNb; i++) {
				for (j= 0; j < statesNb; j++) {
					sum +=gama[ObsIndex-1][j] * transitionProbability[j][i];
				}
				alpha[ObsIndex][i]= emissionProbability[i][sendingIndex-1] * sum;
				sumAlpha += alpha[ObsIndex][i];
				sum = 0;
			}

			for (i= 0; i < statesNb; i++) {	
				gama[ObsIndex][i]= alpha[ObsIndex][i]/sumAlpha;
				//System.out.println("\t" + gama[ObsIndex][i]);
			}
			
			for(double t= preTime; t < setTime; t++) {
				cateValuesN[(int) t] = Double.toString(t);
				YValuesN[(int) t] = gama[ObsIndex][0];;
				
				cateValuesIA[(int) t] = Double.toString(t);
				YValuesIA[(int) t] = gama[ObsIndex][1];;

				cateValuesIP[(int) t] = Double.toString(t);
				YValuesIP[(int) t] = gama[ObsIndex][2];;

				cateValuesC[(int) t] = Double.toString(t);
				YValuesC[(int) t] = gama[ObsIndex][3];;

			}
							
			cateValuesN[(int) setTime] = Double.toString(setTime);
			YValuesN[(int) setTime] = gama[ObsIndex][0];
			
			cateValuesIA[(int) setTime] = Double.toString(setTime);
			YValuesIA[(int) setTime] = gama[ObsIndex][1];

			cateValuesIP[(int) setTime] = Double.toString(setTime);
			YValuesIP[(int) setTime] = gama[ObsIndex][2];

			cateValuesC[(int) setTime] = Double.toString(setTime);
			YValuesC[(int) setTime] = gama[ObsIndex][3];
			
			if (gama[ObsIndex][3] > 0.95 && flag == 0) {
				flag = 0;
				System.out.println("Predict attack: " + setTime + " P: "+ gama[ObsIndex][3]);
				
				for (i=1; i <= alertClassificationNO; i++) {
					//System.out.println(AlertClassification[i]);
					//System.out.println(AlertSeverity[i] + " count: " + AlertClassification[i]);
				}
			}
		}

		System.out.println("The number of alerts in each classification");
		for (i=1; i <= alertClassificationNO; i++) {
			//System.out.println(AlertClassification[i]);
		}
		//System.out.println("predictionCount =" + predictionCount);

		// Set Chart Value
		//for (ObsIndex = 0; ObsIndex < rowCount; ObsIndex++) {
			//cateValuesN[ObsIndex] = Integer.toString(ObsIndex);
			//YValuesN[ObsIndex] = gama[ObsIndex][0];

			/*cateValuesIA[ObsIndex] = Integer.toString(ObsIndex);
			YValuesIA[ObsIndex] = gama[ObsIndex][1];

			cateValuesIP[ObsIndex] = Integer.toString(ObsIndex);
			YValuesIP[ObsIndex] = gama[ObsIndex][2];

			cateValuesC[ObsIndex] = Integer.toString(ObsIndex);
			YValuesC[ObsIndex] = gama[ObsIndex][3];*/
		//}

		// Normal State
		xAxisN.setCategorySeries(cateValuesN);
		ILineSeries seriesN = (ILineSeries) chartN.getSeriesSet().createSeries(SeriesType.LINE, "N");
		seriesN.setLineColor(parent.getDisplay().getSystemColor(SWT.COLOR_DARK_GREEN));
		seriesN.setLineStyle(LineStyle.SOLID);
		seriesN.setYSeries(YValuesN);
		IAxis yAxisN = axisSetN.getYAxis(0);
		yAxisN.adjustRange();
		xAxisN.adjustRange();
		yAxisN.zoomIn();
		yAxisN.zoomOut();
		seriesN.setSymbolType(PlotSymbolType.NONE);	

		// Intrusion Attempt State
		xAxisIA.setCategorySeries(cateValuesIA);
		ILineSeries seriesIA = (ILineSeries) chartIA.getSeriesSet().createSeries(SeriesType.LINE, "P");
		seriesIA.setLineColor(parent.getDisplay().getSystemColor(SWT.COLOR_DARK_MAGENTA));
		seriesIA.setLineStyle(LineStyle.SOLID);
		seriesIA.setYSeries(YValuesIA);
		IAxis yAxisIA = axisSetIA.getYAxis(0);
		yAxisIA.adjustRange();
		xAxisIA.adjustRange();
		yAxisIA.zoomIn();
		yAxisIA.zoomOut();
		seriesIA.setSymbolType(PlotSymbolType.NONE);	

		// Intrusion Progress State
		xAxisIP.setCategorySeries(cateValuesIP);
		ILineSeries seriesIP = (ILineSeries) chartIP.getSeriesSet().createSeries(SeriesType.LINE, "A");
		seriesIP.setLineColor(parent.getDisplay().getSystemColor(SWT.COLOR_DARK_RED));
		seriesIP.setLineStyle(LineStyle.SOLID);
		seriesIP.setYSeries(YValuesIP);
		IAxis yAxisIP = axisSetIP.getYAxis(0);
		yAxisIP.adjustRange();
		xAxisIP.adjustRange();
		yAxisIP.zoomIn();
		yAxisIP.zoomOut();
		seriesIP.setSymbolType(PlotSymbolType.NONE);	

		// Compromize State
		xAxisC.setCategorySeries(cateValuesC);
		ILineSeries seriesC = (ILineSeries) chartC.getSeriesSet().createSeries(SeriesType.LINE, "C");
		seriesC.setLineColor(parent.getDisplay().getSystemColor(SWT.COLOR_RED));
		seriesC.setLineStyle(LineStyle.SOLID);
		seriesC.setYSeries(YValuesC);
		IAxis yAxisC = axisSetC.getYAxis(0);
		yAxisC.adjustRange();
		xAxisC.adjustRange();
		yAxisC.zoomIn();
		yAxisC.zoomOut();
		seriesC.setSymbolType(PlotSymbolType.NONE);	

	}

	private int ReadstatesNb() {
		int Rowcount = 0;

		ResultSet rs = null;

		try {
			rs = c.Query("SELECT COUNT(*) FROM HMMStates");
			rs.next();
			Rowcount = rs.getInt(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}

		return Rowcount;
	}


	private int ReadObservationsNb() {
		int Rowcount = 0;

		ResultSet rs = null;

		try {
			rs = c.Query("SELECT COUNT(*) FROM HMMObservations");
			rs.next();
			Rowcount = rs.getInt(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}

		return Rowcount;
	}

	private int ReadObservations(int index) {
		int Rowcount = 0;
		int Severity = 0;
		double optimizedResult = 0.0;
		ResultSet rs = null;
		int resultValue = 0;


		try {
			rs = c.Query("Select * from Alert, AlertClassification where Alert.AlertClassificationId= AlertClassification.Id" +
					" and Alert.Id > " + MaxId + " " +
			        " ORDER BY DetectDate, DetectTime, Alert.Id ASC LIMIT 1");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				//if (rs.getString ("DetectTime").equals(oldDetectTimeVal)) 
				//	System.out.println(oldDetectTimeVal);
				
				int alertClassificationIdVal = Integer.parseInt(rs.getString ("AlertClassificationId"));
				//System.out.println(alertClassificationIdVal);

				//if (alertClassificationIdVal == 12)
				//	System.out.println("rsh " + setTime);
				
				
				optimizedResult = alert_optimization.run(alertClassificationIdVal);
				String detectTimeVal = rs.getString ("DetectTime");
				oldDetectTimeVal= detectTimeVal;
				MaxId = Integer.parseInt(rs.getString ("Alert.Id"));
				
				AlertClassification[alertClassificationIdVal]++;

				if (optimizedResult >= 4) 
					resultValue= 4;
				else if (optimizedResult >= 3) 
					resultValue= 3;
				else if (optimizedResult >= 2)
					resultValue= 2;
				else
					resultValue= 1;

				AlertSeverity[alertClassificationIdVal]= optimizedResult;

				try {

					date = sdf.parse(detectTimeVal); 
					if (timeFlag == 0) {
						starTime = date.getHours()* 3600 + date.getMinutes() * 60 + date.getSeconds();
						setTime = 0;
						timeFlag = 1;
					} else {
						setTime = (date.getHours()* 3600 + date.getMinutes() * 60 + date.getSeconds()) - starTime;
					}
					
					//if (alertClassificationIdVal == 19)
					//	System.out.println("A"+ alertClassificationIdVal+ " " +setTime);
					//else
					//	System.out.println("A"+ alertClassificationIdVal+ " " +setTime + " " + optimizedResult);


				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}


		return resultValue;	
	}

	private double ReadTransitionValue(int StateId1, int StateId2) {
		double value = 0.0;

		ResultSet rs = null;
		try {
			rs = c.Query("select * from TransitionProbability where StateId1=" + StateId1 + " and StateId2=" + StateId2);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				value =  Double.parseDouble(rs.getString ("Value"));
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return value;
	}

	private double ReadEmissionValue(int StateId, int ObservationeId) {
		double value = 0.0;

		ResultSet rs = null;
		try {
			rs = c.Query("select * from EmissionProbability where StateId=" + StateId + " and ObservationId=" + ObservationeId);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				value =  Double.parseDouble(rs.getString ("Value"));
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return value;
	}


	public void setFocus() {
	}
}
