package org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.eclipse.linuxtools.lttng.SYSPRO.ui.Connect;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.part.ViewPart;
import org.swtchart.Chart;
import org.swtchart.IAxis;
import org.swtchart.IAxisSet;
import org.swtchart.ILineSeries;
import org.swtchart.ILineSeries.PlotSymbolType;
import org.swtchart.ISeries.SeriesType;
import org.swtchart.LineStyle;


public class MonitoringOfflineRiskIndexWithHMMView extends ViewPart {

	public static final String ID = "org.eclipse.ui.tutorials.rcp.part3.MonitoringOfflineRiskIndexWithHMMView";
	public Connect c = new Connect();
	int[] SeverityArray;

	public void createPartControl(Composite parent) {
		Composite top = new Composite(parent, SWT.NONE);
		GridLayout layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		top.setLayout(layout);

		// banner
		Composite bannerN = new Composite(top, SWT.NONE);
		bannerN.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, true));
		bannerN.setSize(1500, 200);

		Composite bannerIA = new Composite(top, SWT.NONE);
		bannerIA.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, true));
		bannerIA.setSize(1500, 200);

		Composite bannerIP = new Composite(top, SWT.NONE);
		bannerIP.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, true));
		bannerIP.setSize(1500, 200);

		Composite bannerC = new Composite(top, SWT.NONE);
		bannerC.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, true));
		bannerC.setSize(1500, 200);

		// Chart for Normal State
		Chart chartN = new Chart(bannerN, SWT.COLOR_CYAN);
		chartN.setSize(1500, 200);
		chartN.getTitle().setText("Normal State");
		chartN.getAxisSet().getXAxis(0).getTitle().setText("Alert");
		chartN.getAxisSet().getYAxis(0).getTitle().setText("Probability");
		IAxisSet axisSetN = chartN.getAxisSet();
		IAxis xAxisN = axisSetN.getXAxis(0);
		// Chart for IA State
		Chart chartIA = new Chart(bannerIA, SWT.COLOR_CYAN);
		chartIA.setSize(1500, 200);
		chartIA.getTitle().setText("Intrusion Attempt State");
		chartIA.getAxisSet().getXAxis(0).getTitle().setText("Alert");
		chartIA.getAxisSet().getYAxis(0).getTitle().setText("Probability");
		IAxisSet axisSetIA = chartIA.getAxisSet();
		IAxis xAxisIA = axisSetIA.getXAxis(0);
		// Chart for IP State
		Chart chartIP = new Chart(bannerIP, SWT.COLOR_CYAN);
		chartIP.setSize(1500, 200);
		chartIP.getTitle().setText("Intrusion Progress State");
		chartIP.getAxisSet().getXAxis(0).getTitle().setText("Alert");
		chartIP.getAxisSet().getYAxis(0).getTitle().setText("Probability");
		IAxisSet axisSetIP = chartIP.getAxisSet();
		IAxis xAxisIP = axisSetIP.getXAxis(0);
		// Chart for C State
		Chart chartC = new Chart(bannerC, SWT.COLOR_CYAN);
		chartC.setSize(1500, 200);
		chartC.getTitle().setText("Compromize State");
		chartC.getAxisSet().getXAxis(0).getTitle().setText("Alert");
		chartC.getAxisSet().getYAxis(0).getTitle().setText("Probability");
		IAxisSet axisSetC= chartC.getAxisSet();
		IAxis xAxisC = axisSetC.getXAxis(0);


		ResultSet rs = null;

		int rowCount = -1;

		try {
			rs = c.Query("SELECT COUNT(*) FROM Alert where DetectTime > '12:01:50' and DetectTime < '12:09:00'");
			rs.next();
			rowCount = rs.getInt(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		String[] cateValuesN = new String[rowCount];
		double[] YValuesN = new double[rowCount];
		String[] cateValuesIA = new String[rowCount];
		double[] YValuesIA = new double[rowCount];
		String[] cateValuesIP = new String[rowCount];
		double[] YValuesIP= new double[rowCount];
		String[] cateValuesC = new String[rowCount];
		double[] YValuesC = new double[rowCount];
		SeverityArray = new int[rowCount];

		// Initialize 
		int i, j, ObsIndex, sendingIndex;
		double sum;
		double sumAlpha;
		int statesNb = 0;
		int observationsNb = 0;

		statesNb = ReadstatesNb();
		observationsNb = ReadObservationsNb();

		double[][] alpha = new double[rowCount][statesNb];
		double[][] gama = new double[rowCount][statesNb];
		double[][] transitionProbability = new double[statesNb][statesNb];
		double[][] emissionProbability = new double[statesNb][observationsNb];
		double[] startProbability = new double[statesNb];

		startProbability [0] = 1.0; 
		startProbability [1] = 0.0;
		startProbability [2] = 0.0;
		startProbability [3] = 0.0;

		for (i= 0; i < statesNb; i++) {	
			for (j= 0; j < statesNb; j++) {
				transitionProbability[i][j] = ReadTransitionValue(i+1,j+1);
			}
		}

		for (i= 0; i < statesNb; i++) {	
			for (j= 0; j < observationsNb; j++) {
				emissionProbability[i][j] = ReadEmissionValue(i+1,j+1);
			}
		}

		// Start Analysis
		System.out.println("\tStarting of Hidden Markov Model analysis...\n");

		sendingIndex = ReadObservations(0);
		sumAlpha = 0;
		for (i= 0; i < statesNb; i++) {	
			alpha[0][i]= startProbability[i] * emissionProbability[i][sendingIndex-1];
			sumAlpha += alpha[0][i];
		}

		for (i= 0; i < statesNb; i++) {	
			gama[0][i]= alpha[0][i]/sumAlpha;
			System.out.println("\t" + gama[0][i]);
		}
		System.out.println("-----------------------------");


		for (ObsIndex = 1; ObsIndex < rowCount; ObsIndex++) {
			sumAlpha = 0;
			sum = 0;
			sendingIndex = ReadObservations(ObsIndex); 
			for (i= 0; i < statesNb; i++) {
				for (j= 0; j < statesNb; j++) {
					sum +=gama[ObsIndex-1][j] * transitionProbability[j][i];
				}
				alpha[ObsIndex][i]= emissionProbability[i][sendingIndex-1] * sum;
				sumAlpha += alpha[ObsIndex][i];
				sum = 0;
			}
			double RI= 0;
			double[] AssetValue = new double[5];
			
			AssetValue[1]= 0;
			AssetValue[2]= 25;
			AssetValue[3]= 50;
			AssetValue[4]= 100;

			for (i= 0; i < statesNb; i++) {	
				gama[ObsIndex][i]= alpha[ObsIndex][i]/sumAlpha;
				RI= RI + gama[ObsIndex][i] * AssetValue[i+1];
				System.out.println("\t" + gama[ObsIndex][i]);
			}
			
			System.out.println("Risk Impact:" + RI + "-----------------------------");
		}


		// Set Chart Value
		for (ObsIndex = 0; ObsIndex < rowCount; ObsIndex++) {
			cateValuesN[ObsIndex] = Integer.toString(ObsIndex);
			YValuesN[ObsIndex] = gama[ObsIndex][0];

			cateValuesIA[ObsIndex] = Integer.toString(ObsIndex);
			YValuesIA[ObsIndex] = gama[ObsIndex][1];

			cateValuesIP[ObsIndex] = Integer.toString(ObsIndex);
			YValuesIP[ObsIndex] = gama[ObsIndex][2];

			cateValuesC[ObsIndex] = Integer.toString(ObsIndex);
			YValuesC[ObsIndex] = gama[ObsIndex][3];
		}

		// Normal State
		xAxisN.setCategorySeries(cateValuesN);
		ILineSeries seriesN = (ILineSeries) chartN.getSeriesSet().createSeries(SeriesType.LINE, "N");
		seriesN.setLineColor(parent.getDisplay().getSystemColor(SWT.COLOR_DARK_GREEN));
		seriesN.setLineStyle(LineStyle.SOLID);
		seriesN.setYSeries(YValuesN);
		IAxis yAxisN = axisSetN.getYAxis(0);
		yAxisN.adjustRange();
		xAxisN.adjustRange();
		yAxisN.zoomIn();
		yAxisN.zoomOut();
		seriesN.setSymbolType(PlotSymbolType.NONE);	

		// Intrusion Attempt State
		xAxisIA.setCategorySeries(cateValuesIA);
		ILineSeries seriesIA = (ILineSeries) chartIA.getSeriesSet().createSeries(SeriesType.LINE, "P");
		seriesIA.setLineColor(parent.getDisplay().getSystemColor(SWT.COLOR_DARK_MAGENTA));
		seriesIA.setLineStyle(LineStyle.SOLID);
		seriesIA.setYSeries(YValuesIA);
		IAxis yAxisIA = axisSetIA.getYAxis(0);
		yAxisIA.adjustRange();
		xAxisIA.adjustRange();
		yAxisIA.zoomIn();
		yAxisIA.zoomOut();
		seriesIA.setSymbolType(PlotSymbolType.NONE);	

		// Intrusion Progress State
		xAxisIP.setCategorySeries(cateValuesIP);
		ILineSeries seriesIP = (ILineSeries) chartIP.getSeriesSet().createSeries(SeriesType.LINE, "A");
		seriesIP.setLineColor(parent.getDisplay().getSystemColor(SWT.COLOR_DARK_RED));
		seriesIP.setLineStyle(LineStyle.SOLID);
		seriesIP.setYSeries(YValuesIP);
		IAxis yAxisIP = axisSetIP.getYAxis(0);
		yAxisIP.adjustRange();
		xAxisIP.adjustRange();
		yAxisIP.zoomIn();
		yAxisIP.zoomOut();
		seriesIP.setSymbolType(PlotSymbolType.NONE);	

		// Compromize State
		xAxisC.setCategorySeries(cateValuesC);
		ILineSeries seriesC = (ILineSeries) chartC.getSeriesSet().createSeries(SeriesType.LINE, "C");
		seriesC.setLineColor(parent.getDisplay().getSystemColor(SWT.COLOR_RED));
		seriesC.setLineStyle(LineStyle.SOLID);
		seriesC.setYSeries(YValuesC);
		IAxis yAxisC = axisSetC.getYAxis(0);
		yAxisC.adjustRange();
		xAxisC.adjustRange();
		yAxisC.zoomIn();
		yAxisC.zoomOut();
		seriesC.setSymbolType(PlotSymbolType.NONE);	

	}

	private int ReadstatesNb() {
		int Rowcount = 0;

		ResultSet rs = null;
		
		try {
			rs = c.Query("SELECT COUNT(*) FROM HMMStates");
			rs.next();
			Rowcount = rs.getInt(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		return Rowcount;
	}


	private int ReadObservationsNb() {
		int Rowcount = 0;

		ResultSet rs = null;
		
		try {
			rs = c.Query("SELECT COUNT(*) FROM HMMObservations");
			rs.next();
			Rowcount = rs.getInt(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		return Rowcount;
	}

	private int ReadObservations(int index) {
		int Rowcount = 0;
		int Severity = 0;

		ResultSet rs = null;
		if (index == 0) {

			try {
				rs = c.Query("Select * from Alert, AlertClassification where Alert.AlertClassificationId= AlertClassification.Id and " +
						" DetectTime > '12:01:50' and DetectTime < '12:09:00' " +
						" ORDER BY DetectDate, DetectTime, Alert.Id ASC");
			} catch (SQLException e) {
				e.printStackTrace();
			}
			try {
				while (rs.next ())
				{

					if (rs.getString ("Severity").toString().contains("Low")) {
						Severity = 1;
					} 
					if (rs.getString ("Severity").contains("Medium")) {
						Severity = 2;
					} 
					if (rs.getString ("Severity").contains("High")) {
						Severity = 3;
					}

					SeverityArray[Rowcount++]= Severity;

				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}

		return SeverityArray[index];	
	}

	private double ReadTransitionValue(int StateId1, int StateId2) {
		double value = 0.0;

		ResultSet rs = null;
		try {
			rs = c.Query("select * from TransitionProbability where StateId1=" + StateId1 + " and StateId2=" + StateId2);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				value =  Double.parseDouble(rs.getString ("Value"));
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return value;
	}

	private double ReadEmissionValue(int StateId, int ObservationeId) {
		double value = 0.0;

		ResultSet rs = null;
		try {
			rs = c.Query("select * from EmissionProbability where StateId=" + StateId + " and ObservationId=" + ObservationeId);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				value =  Double.parseDouble(rs.getString ("Value"));
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return value;
	}


	public void setFocus() {
	}
}
