package org.eclipse.linuxtools.lttng.SYSPRO.file;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Set;
import java.util.TreeMap;

import org.eclipse.linuxtools.lttng.SYSPRO.cpu.KernelProcess;
import org.eclipse.linuxtools.lttng.SYSPRO.io.EventData;

public class FileOperationList implements Comparable {
	Long pid;
	String cmd;
	String filename;
	ArrayList<FileOperation> operation ;
	ArrayList<SnodeLink> members;
	String fsmcurrentstate;
	FileFSM fsm;
	
	public FileOperationList(Long fd, Long pid,String filename,String operation,String operand, String cmd, Long time) {
		this.pid= pid;
		this.cmd = cmd;
		this.filename= filename;
		this.operation = new ArrayList<FileOperation>();
		this.operation.add(new FileOperation(fd,operation, operand, time));
		this.fsm = new FileFSM();
	}
	public FileOperationList() {
		this.fsm = new FileFSM();
	}

	public void addAMember(int quark, Long startTime) {
		if (this.members == null)
			this.members = new ArrayList<SnodeLink>();
		members.add(new SnodeLink(quark, startTime));
	}
	
	public ArrayList<SnodeLink> getMembers() {
		return this.members;
	}
	
	public void clearMembers() {
		this.members = null;
	}
	
	public String getOperation(Double time) {
		//return this.operation.get(time).getOperation();
		return "";
	}
	public String getAllOperaions(String operation) {
		return this.operation.toString();
	}
	public Long getPID(){
		return this.pid;
	}
	public String getFilename() {
		return filename;
	}
	public String getCMD() {
		return cmd;
	}
	public FileFSM getFSM() {
		return this.fsm;
	}
	
	public ArrayList<FileOperation> getOperation() {
		return operation;
	}
	public void setOperation(String operation,Double time) {
		//this.operation.put(time,);
	}
	public void updateOperation(Long fd, String operation,String operand,Long time) {
		this.operation.add(new FileOperation(fd, operation, operand, time));

	}
	public void updateLastOperation(FileOperation op) {
		FileOperation fop = this.operation.get(this.operation.size()-1);
		//fop.setFd(fd);
		//fop.setOperation(operation);
		fop.setOperand(op.getOperand());
		//fop.time(tim)
		//this.operation.get(0).set(new FileOperation(fd, operation, operand, time));

	}
	public void setFilename(String filename) {
		this.filename = filename;
	}
	
	public boolean equals(Object other) {
		if (other instanceof FileOperationList) {
			FileOperationList p = (FileOperationList) other;
			if (p.operation == this.operation) {
				return true;
			}
		}
		return false;
	}
	public int hashCode() {
		return this.operation.hashCode();
	}
	@Override
	public int compareTo(Object o) {
		// TODO Auto-generated method stub
		return 0;
	}
	public String toString()
	{
		Enumeration e = Collections.enumeration(this.operation);
		String operationStr="";
		while(e.hasMoreElements()){
			operationStr += e.nextElement().toString();
		}
		 return  pid.toString() + ":" + filename + ":" +operationStr;
	}
	/*public int compareTo(Object other) {
		if (other instanceof FileOperationList) {
			FileOperationList p = (FileOperationList) other;
			return this.operation[count-1].getFilename().compareTo(p.operation.getFilename());
		}
		return -1;
	}*/

}

