package org.eclipse.linuxtools.lttng.SYSPRO.file;

import java.util.ArrayList;
import java.util.HashMap;

import org.eclipse.linuxtools.lttng.SYSPRO.io.EventData;

public class Snode implements Comparable {
	private Long pid;
	private int processnameId;
	private String operation;
	private int operationId;
	private int operand1Id;
	private int operand2Id;
	private String operand1;
	private String operand2;
	private int ret;
	private SnodeLink parent;
	private ArrayList<SnodeLink> children;
	private Long starttime; //starting link from lowest abstract events to the raw events
	private Long endtime;
	
	public Snode(){}
	
	public Snode(Long pid, int processnameId, int operationId,int operand1Id) {
		this.pid = pid;
		this.processnameId = processnameId;
		this.operationId = operationId;
		this.operand1Id = operand1Id;
	}
	public Snode(Long pid, int processnameId, int operationId,String operand1) {
		this.pid = pid;
		this.processnameId = processnameId;
		this.operationId = operationId;
		this.operand1 = operand1;
	}
	
	
	public Snode(Long pid, int processNameId, int operationId,int operand1Id, Long startTime,Long endTime) {
		this.pid = pid;
		this.processnameId = processNameId;
		this.operationId = operationId;
		this.operand1Id = operand1Id;
		this.starttime = startTime;
		this.endtime = endTime;
	}
	public Snode(Long pid, int processNameId, int operationId,String operand1, Long startTime,Long endTime) {
		this.pid = pid;
		this.processnameId = processNameId;
		this.operationId = operationId;
		this.operand1 = operand1;
		this.starttime = startTime;
		this.endtime = endTime;
	}
	
	
	public Snode(Long pid,int processNameId, int operationId,int operand1Id, int quark, Long startTime) {
		this.pid = pid;
		this.processnameId = processNameId;
		this.operationId = operationId;
		this.operand1Id = operand1Id;
		if (this.children == null) {
			this.children = new ArrayList<SnodeLink>();
		}
		this.children.add(new SnodeLink(quark, startTime));
	}
	public Snode(Long pid,int processNameId, int operationId,String operand1, int quark, Long startTime) {
		this.pid = pid;
		this.processnameId = processNameId;
		this.operationId = operationId;
		this.operand1 = operand1;
		if (this.children == null) {
			this.children = new ArrayList<SnodeLink>();
		}
		this.children.add(new SnodeLink(quark, startTime));
	}
	
	
	public Snode(Long pid,int operationId,int operand1Id, int quark, Long startTime, boolean parent) {
		this.pid = pid;
		this.operationId = operationId;
		this.operand1Id = operand1Id;
		if (parent)
			this.parent = new SnodeLink(quark, startTime);
	}

	public void setChildren(ArrayList<SnodeLink> children){
		this.children = children;
	}
	public ArrayList<SnodeLink> getChildren(){
		return this.children;
	}
	
	public void addParent(int quark, Long startTime)
	{
		this.parent = new SnodeLink(quark, startTime);
	}
	/*public Snode(Long pid,int operationId,String operand) {
		this.pid = pid;
		this.operationId = operationId;
		this.operand1 = operand;
		this.startTimes = null;
	}*/
	
	public Snode(Long pid,String operation,String operand, Long time) {
		this.pid = pid;
		this.operation = operation;
		this.operand1 = operand;
		
	}
	
	public Snode(Long pid,String filename, String operation,String operand, Long time) {
	}
	
	public void setOperaion(Long pid, String operation,String operand, Long time) {
	}
	
	public void setOperaion(Long pid, String filename, String operation,String operand, Long time) {
	}
	
	public void setOperand(String operand){
		
	}
	
	public Long getPid(){
		return this.pid;
	}
	
	
	public String getOperation(){
		return this.operation;
	}
	public int getOperationId(){
		return this.operationId;
	}
	
	public int getOperand1(){
		return this.operand1Id;
	}
	
	public int getOperand2(){
		return this.operand2Id;
	}
	
	public String getOperand() {
		return this.operand1;
	}
	
	public String getOperands(){
		String output = "";
		if (operand1 != null)
			output += operand1;
		if (operand2 != null)
			output += ", " + operand2;
		return output;
	}
	
	public int getProcessname(){
		return this.processnameId;
	}
		
	public String getAllOperaions(String operation) {
		return this.operation.toString();
	}
	
	public int hashCode() {
		return this.operation.hashCode();
	}
	
	@Override
	public int compareTo(Object o) {
		// TODO Auto-generated method stub
		return 0;
	}
	
	/*public int compareTo(Object other) {
		if (other instanceof FileList) {
			FileList p = (FileList) other;
			return this.operation.compareTo(p.operation);
		}
		return -1;
	}*/
	
	public int getOperand1Id(){
		return this.operand1Id;
	}
	
	public int getoperand2Id(){
		return this.operand2Id;
	}
	
	public Long getstartTimeofChildren(){ //this is for lowset level of abstract events (system call level)
		return this.starttime;
	}
	public Long getendTimeofChildren(){ //this is for lowset level of abstract events (system call level)
		return this.endtime;
	}
	
	public SnodeLink getParent(){
		return this.parent;
	}
	

	
	public String toString(){
		return "pid= " + pid + ", opID=" + operationId + ", operand1: " + operand1; 
		//return "pid= " + pid + ", opID=" + operationId + ", operand1: ";
	}
}



