package org.eclipse.linuxtools.lttng.SYSPRO.file;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;
import java.util.TreeMap;

import org.eclipse.linuxtools.lttng.jni.JniEvent;
import org.eclipse.linuxtools.lttng.jni.JniTrace;
import org.eclipse.linuxtools.lttng.SYSPRO.UsageStats;
import org.eclipse.linuxtools.lttng.SYSPRO.cpu.KernelProcess;
import org.eclipse.linuxtools.lttng.SYSPRO.cpu.TraceEventHandlerProcess;
import org.eclipse.linuxtools.lttng.SYSPRO.io.EventData;
import org.eclipse.linuxtools.lttng.SYSPRO.io.TraceEventHandlerBase;
import org.eclipse.linuxtools.lttng.SYSPRO.io.TraceHook;
import org.eclipse.linuxtools.lttng.SYSPRO.io.TraceReader;
import org.eclipse.linuxtools.lttng.SYSPRO.file.FileFSM;

public class TraceEventHandlerGeneral extends TraceEventHandlerBase {
	
	int count; 
	JniTrace trace;
	
	
	HashMap<String, FileOperationList> fileInfo;// <filename,FileOperationList>
	
	private int numCpu;
	private double start;
	private double end;
	private TraceReader traceReader;
	private Set<EventData> eventList;
	//private long count;
	
	public TraceEventHandlerGeneral() {
		super();
		hooks.add(new TraceHook());
	}
	@Override
	public void handleInit(TraceReader reader, JniTrace trace) {
		this.trace = trace;
		count = 0;
		numCpu = trace.getCpuNumber();
		start = (double) trace.getStartTime().getTime();
		end = (double) trace.getEndTime().getTime();
		eventList = new HashSet();
	}
	
	public void handle_all_event(TraceReader reader, JniEvent event) {
		int i=0;
		count++;
		
		eventList.add(new EventData(event));
	}
	@Override
	public void handleComplete(TraceReader reader) {
		System.out.print("count: "+count);
		// finish intervals until trace end
	}
	public Set<EventData> getEventList(){
		return this.eventList;
		
	}
}
