/*
 * @(#)NameBase.java	1.7 06/08/06
 *
 * Copyright 2002 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package org.eclipse.linuxtools.lttng.SYSPRO.fsm ;

import org.eclipse.linuxtools.lttng.SYSPRO.fsm.Action ;
import org.eclipse.linuxtools.lttng.SYSPRO.fsm.State ;
import org.eclipse.linuxtools.lttng.SYSPRO.fsm.Guard ;
import org.eclipse.linuxtools.lttng.SYSPRO.fsm.Input ;

import java.util.StringTokenizer ;

public class NameBase {
    private String name ;
    private String toStringName ;

    // Return just the name of the class, not the full qualified name.
    private String getClassName() 
    {
	String fqn = this.getClass().getName() ;
	StringTokenizer st = new StringTokenizer( fqn, "." ) ;
	String token = st.nextToken() ;
	while (st.hasMoreTokens())
	    token = st.nextToken() ;
	return token ;
    }

    private String getPreferredClassName()
    {
	if (this instanceof Action)
	    return "Action" ;
	if (this instanceof State)
	    return "State" ;
	if (this instanceof Guard)
	    return "Guard" ;
	if (this instanceof Input)
	    return "Input" ;
	return getClassName() ;
    }

    public NameBase( String name ) 
    { 
	this.name = name ;
	toStringName = getPreferredClassName() + "[" + name + "]" ;
    }

    public String getName() 
    {
	return name ;
    }

    public String toString() {
	return toStringName ;
    }
}