package org.eclipse.linuxtools.lttng.SYSPRO.model;

import org.eclipse.linuxtools.lttng.SYSPRO.model.Task.TaskState;
import org.eclipse.linuxtools.lttng.SYSPRO.model.state.ExitInfo;
import org.eclipse.linuxtools.lttng.SYSPRO.model.state.IRQInfo;
import org.eclipse.linuxtools.lttng.SYSPRO.model.state.SoftIRQInfo;
import org.eclipse.linuxtools.lttng.SYSPRO.model.state.StateInfo;
import org.eclipse.linuxtools.lttng.SYSPRO.model.state.SyscallInfo;
import org.eclipse.linuxtools.lttng.SYSPRO.model.state.TrapInfo;
import org.eclipse.linuxtools.lttng.SYSPRO.model.state.UserInfo;
import org.eclipse.linuxtools.lttng.SYSPRO.model.state.WaitInfo;
import org.eclipse.linuxtools.lttng.SYSPRO.model.state.ZombieInfo;

public class StateInfoFactory {

	public static StateInfo makeStateInfo(TaskState state) {
		StateInfo info = null;
		switch(state) {
		case IRQ:
			info = new IRQInfo();
			break;
		case SOFTIRQ:
			info = new SoftIRQInfo();
			break;
		case SYSCALL:
			info = new SyscallInfo();
			break;
		case WAIT:
			info = new WaitInfo();
			break;
		case TRAP:
			info = new TrapInfo();
			break;
		case ZOMBIE:
			info = new ZombieInfo();
			break;
		case USER:
			info = new UserInfo();
			break;
		case EXIT:
			info = new ExitInfo();
			break;
		default:
			break;
		}
		if (info != null)
			info.setTaskState(state);
		return info;
	}

}
