package org.eclipse.linuxtools.lttng.SYSPRO.model.state;

import java.util.Collections;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Map;

import org.eclipse.linuxtools.lttng.SYSPRO.model.Task.TaskState;
import org.eclipse.linuxtools.lttng.SYSPRO.model.state.StateInfo.Field;

public class SyscallInfo extends StateInfo {

	private int syscallId;
	private int retCode;

	public SyscallInfo() {
		setTaskState(TaskState.SYSCALL);
	}

	public void setRetCode(int retCode) {
		this.retCode = retCode;
	}

	public int getRetCode() {
		return retCode;
	}

	public void setSyscallId(int syscallId) {
		this.syscallId = syscallId;
	}

	public int getSyscallId() {
		return syscallId;
	}
	@Override
	public String toString() {		
		String output = "[syscallD= " + String.valueOf(syscallId) + ", start= " + String.valueOf(this.start)+ ", end= " + String.valueOf(this.end);	
		for (Map.Entry<Field,Object> entry : this.fieldInfo.entrySet()) {
		    Field key = entry.getKey();
		    Object value = entry.getValue();
		    if (value != null){
		    	output = output + ", "+ key.toString()+"= "+ value;
		    }
		}
		return output+ "]";
	}
}
