package org.eclipse.linuxtools.lttng.SYSPRO.net;

import org.eclipse.linuxtools.lttng.SYSPRO.net.TraceEventHandlerNet.Family;

public class NetworkPacket {
	private String title;
	private Long pid;
	private Long fd;
	private Long src;
	private Long srcport;
	private Long dst;
	private Long dstport;
	private Long protocol;
	private Long totalLen;
	private String status; //0:created,Long1:connected,Long2:closed;
	private String value;  //syn,fin,ack, ... values.
	private Long time;
	
	public enum Family{ //or Domain
		AF_UNSPEC, AF_LOCAL, AF_INET, AF_AX25, AF_IPX, AF_APPLETALK, AF_NETROM, AF_BRIDGE, AF_ATMPVC, AF_X25
		, AF_INET6, AF_ROSE, AF_DECnet, AF_NETBEUI, AF_SECURITY, AF_KEY, AF_NETLINK, AF_ROUTE, AF_PACKET, AF_ASH, AF_ECONET, AF_ATMSVC
		, AF_SNA, AF_IRDA, AF_PPPOX, AF_WANPIPE, AF_BLUETOOTH, AF_IUCV, AF_RXRPC, AF_MA	
	}
	
	public enum Type{
		SOCK_DUMMY, SOCK_STREAM, SOCK_DGRAM, SOCK_RAW, SOCK_RDM, SOCK_SEQPACKET
	}
	
	public enum Protocol{
		IPPROTO_IP,	IPPROTO_ICMP, IPPROTO_IGMP, IPPROTO_DUMMY3, IPPROTO_IPIP, IPPROTO_DUMMY5, IPPROTO_TCP, IPPROTO_DUMMY7, IPPROTO_EGP, IPPROTO_DUMMY9, IPPROTO_DUMMY10, IPPROTO_DUMMY11, IPPROTO_PUP, IPPROTO_DUMMY13, IPPROTO_DUMMY14, IPPROTO_DUMMY15, IPPROTO_DUMMY16, IPPROTO_UDP
	}
	
	public NetworkPacket(Long pid,Long fd,Long src,Long srcport,Long dst,Long dstport,Long protocol,String status,String value){
		this.pid = pid;
		this.fd = fd;
		this.src = src;
		this.srcport = srcport;
		this.dst = dst;
		this.dstport = dstport;
		this.protocol = protocol;
		this.value = value;
		this.status = status;
	}
	public NetworkPacket(String title, Long pid,Long fd,Long src,Long srcport,Long dst,Long dstport,Long protocol,Long totalLen, String value, String status, Long time){
		this.title = title;
		this.pid = pid;
		this.fd = fd;
		this.src = src;
		this.srcport = srcport;
		this.dst = dst;
		this.dstport = dstport;
		this.protocol = protocol;
		this.totalLen = totalLen;
		this.status = status;
		this.value = value;
		this.time = time;
	}
	
	public void setPid (Long pid){
		this.pid = pid;
	}
	
	public void setFd (Long fd){
		this.fd = fd;
	}
	
	public void setTotalLen (Long tootalLen){
		this.totalLen = tootalLen;
	}
	
	public void setTime (Long time){
		this.time = time;
	}
	
	public void setNetAddress (Long src, Long srcport, Long dst, Long dstport,Long protocol){
		this.src = src;
		this.srcport = srcport;
		this.dst = dst;
		this.dstport = dstport;
		this.protocol = protocol;
	}
	
	public void setStatus(String status){
		this.status = status;
	}
	public void setValue(String value){
		this.value = value;
	}
	
	public Long getTime (){
		return this.time;
	}
	
	public Long getPid (){
		return this.pid;
	}
	
	public Long getFd (){
		return this.fd;
	}
	public String getStatus (){
		return this.status;
	}
	public Long getTotalLen (){
		return this.totalLen;
	}
	public Long getSrc(){
		return this.src;
	}
	public Long getSrcPort(){
		return this.srcport;
	}
	public Long getDst(){
		return this.dst;
	}
	public Long getDstPort(){
		return this.dstport;
	}
	public Long getProtocol(){
		return this.protocol;
	}
	public String getStrProtocol(){
		
		if (this.protocol<= 17)
			return Protocol.class.getEnumConstants()[this.protocol.intValue()].toString();
		else
			return this.protocol.toString();
	}
	public String getValue(){
		return this.value;
	}
	public String getTitle(){
		return this.title;
	}
	public String ipToString(long i) {
	    return ((i >> 24 ) & 0xFF) + "." +
	           ((i >> 16 ) & 0xFF) + "." +
	           ((i >>  8 ) & 0xFF) + "." +
	           ( i        & 0xFF);
	}
}
