package org.eclipse.linuxtools.lttng.SYSPRO.ui;

import java.util.ArrayList;

import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Health.HealthView;
import org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention.ResponseCriteriaView;
import org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention.ResponseCriteriaWeightView;
import org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention.ResponseEffectivenessView;
import org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention.ResponseNegativeValueLevelView;
import org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention.ResponseNegativeValueView;
import org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention.ResponsePositiveValueLevelView;
import org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention.ResponsePositiveValueView;
import org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention.ResponseView;
import org.eclipse.linuxtools.lttng.SYSPRO.AlertOptimization.AlertClassificationView;
import org.eclipse.linuxtools.lttng.SYSPRO.AttackGraph.AttackGraphView;
import org.eclipse.linuxtools.lttng.SYSPRO.AlertOptimization.AlertCorrelation1View;
import org.eclipse.linuxtools.lttng.SYSPRO.AlertOptimization.AlertCorrelation2View;
import org.eclipse.linuxtools.lttng.SYSPRO.AlertOptimization.AlertCorrelationView;
import org.eclipse.linuxtools.lttng.SYSPRO.AlertOptimization.AlertView;
import org.eclipse.linuxtools.lttng.SYSPRO.AlertOptimization.MonitoringOfflineAlertOptimizationView;
import org.eclipse.linuxtools.lttng.SYSPRO.AlertOptimization.RelationshipAlertClassificationANDResourceView;
import org.eclipse.linuxtools.lttng.SYSPRO.Prediction.HMMObservationsView;
import org.eclipse.linuxtools.lttng.SYSPRO.Prediction.HMMStatesView;
import org.eclipse.linuxtools.lttng.SYSPRO.Prediction.MonitoringOfflinePredictionOverTimeView;
import org.eclipse.linuxtools.lttng.SYSPRO.Prediction.MonitoringOfflinePredictionView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.CriteriaLinguisticVariablesView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.DecisionMakersView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.HostResourceView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.HostView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.MonitoringOfflineRiskIndexWithFuzzyView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.MonitoringOfflineRiskIndexWithHMMView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.RatingsLinguisticVariablesView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.ResourceCatView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.ResourceCriteriaView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.ResourceCriteriaWeightView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.ResourceRankingView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.ResourceValueLevelView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.ResourceValueView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.ResourceView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.VulnerabilityCriteriaView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.VulnerabilityCriteriaWeightView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.VulnerabilityEffectLevelView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.VulnerabilityEffectView;
import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.VulnerabilityRankingView;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.ViewPart;

public class NavigationView extends ViewPart {
	public static final String ID = "org.eclipse.ui.tutorials.rcp.part3.navigationView";
	public static Composite static_parent;

	private TreeViewer viewer;

	class TreeObject {
		private String name;
		private TreeParent parent;

		public TreeObject(String name) {
			this.name = name;
		}

		public String getName() {
			return name;
		}

		public void setParent(TreeParent parent) {
			this.parent = parent;
		}

		public TreeParent getParent() {
			return parent;
		}

		public String toString() {
			return getName();
		}
	}

	class TreeParent extends TreeObject {
		private ArrayList children;

		public TreeParent(String name) {
			super(name);
			children = new ArrayList();
		}

		public void addChild(TreeObject child) {
			children.add(child);
			child.setParent(this);
		}

		public void removeChild(TreeObject child) {
			children.remove(child);
			child.setParent(null);
		}

		public TreeObject[] getChildren() {
			return (TreeObject[]) children.toArray(new TreeObject[children
					.size()]);
		}

		public boolean hasChildren() {
			return children.size() > 0;
		}
	}

	class ViewContentProvider implements IStructuredContentProvider,
			ITreeContentProvider {

		public void inputChanged(Viewer v, Object oldInput, Object newInput) {
		}

		public void dispose() {
		}

		public Object[] getElements(Object parent) {
			return getChildren(parent);
		}

		public Object getParent(Object child) {
			if (child instanceof TreeObject) {
				return ((TreeObject) child).getParent();
			}
			return null;
		}

		public Object[] getChildren(Object parent) {
			if (parent instanceof TreeParent) {
				return ((TreeParent) parent).getChildren();
			}
			return new Object[0];
		}

		public boolean hasChildren(Object parent) {
			if (parent instanceof TreeParent)
				return ((TreeParent) parent).hasChildren();
			return false;
		}
	}

	class ViewLabelProvider extends LabelProvider {

		public String getText(Object obj) {
			return obj.toString();
		}

		public Image getImage(Object obj) {
			String imageKey = ISharedImages.IMG_OBJ_ELEMENT;
			if (obj instanceof TreeParent)
				imageKey = ISharedImages.IMG_OBJ_FOLDER;
			return PlatformUI.getWorkbench().getSharedImages()
					.getImage(imageKey);
		}
	}

	/**
	 * We will set up a dummy model to initialize tree heararchy. In real code,
	 * you will connect to a real model and expose its hierarchy.
	 */
	private TreeObject createDummyModel() {

		// Alert Optimization Section
		TreeObject to_AG_1 = new TreeObject("Generate");

		TreeParent p0 = new TreeParent("Attack Graph");

		p0.addChild(to_AG_1);

		// Alert Optimization Section
		TreeObject to_AO_1 = new TreeObject("Alert Classification");
		TreeObject to_AO_2 = new TreeObject(
				"Relationship between Alert Classification and Resource");
		TreeObject to_AO_3 = new TreeObject("Alert Correlatiom Matrix1 (ACM1)");
		TreeObject to_AO_4 = new TreeObject("Alert Correlatiom Matrix2 (ACM2)");
		TreeObject to_AO_5 = new TreeObject("Alert");
		TreeObject to_AO_6 = new TreeObject(
				"Monitoring Offline Alert Optimization");

		TreeParent p1 = new TreeParent("Alert Optimization");

		p1.addChild(to_AO_1);
		p1.addChild(to_AO_2);
		p1.addChild(to_AO_3);
		p1.addChild(to_AO_4);
		p1.addChild(to_AO_5);
		p1.addChild(to_AO_6);

		// Risk Assessment Section
		TreeObject to_RA_1 = new TreeObject("Decision Makers");
		TreeObject to_RA_2 = new TreeObject("Criteria Linguistic Variables");
		TreeObject to_RA_3 = new TreeObject("Ratings Linguistic Variables");
		TreeObject to_RA_4 = new TreeObject("Resource Criteria");
		TreeObject to_RA_5 = new TreeObject("Resource Criteria Weight");
		TreeObject to_RA_6 = new TreeObject("Hosts");
		TreeObject to_RA_7 = new TreeObject("Resource Category");
		TreeObject to_RA_8 = new TreeObject("Resources");
		TreeObject to_RA_9 = new TreeObject("Host Resources");
		TreeObject to_RA_10 = new TreeObject("Resource Value");
		TreeObject to_RA_11 = new TreeObject("Resource Ranking (TOPSIS)");
		TreeObject to_RA_12 = new TreeObject("Resource Value Level (SAW)");
		TreeObject to_RA_13 = new TreeObject("Vulnerability Criteria");
		TreeObject to_RA_14 = new TreeObject("Vulnerability Criteria Weight");
		TreeObject to_RA_15 = new TreeObject("Vulnerability Effect");
		TreeObject to_RA_16 = new TreeObject("Vulnerability Ranking (TOPSIS)");
		TreeObject to_RA_17 = new TreeObject("Vulnerability Effect Level (SAW)");
		TreeObject to_RA_18 = new TreeObject(
				"Monitoring Offline Risk Index with Fuzzy");
		TreeObject to_RA_19 = new TreeObject(
				"Monitoring Offline Risk Index with HMM");

		TreeParent p2 = new TreeParent("Risk Assessment");

		p2.addChild(to_RA_1);
		p2.addChild(to_RA_2);
		p2.addChild(to_RA_3);
		p2.addChild(to_RA_4);
		p2.addChild(to_RA_5);
		p2.addChild(to_RA_6);
		p2.addChild(to_RA_7);
		p2.addChild(to_RA_8);
		p2.addChild(to_RA_9);
		p2.addChild(to_RA_10);
		p2.addChild(to_RA_11);
		p2.addChild(to_RA_12);
		p2.addChild(to_RA_13);
		p2.addChild(to_RA_14);
		p2.addChild(to_RA_15);
		p2.addChild(to_RA_16);
		p2.addChild(to_RA_17);
		p2.addChild(to_RA_18);
		p2.addChild(to_RA_19);

		// Prediction Section
		TreeObject to_P_1 = new TreeObject("HMM States");
		TreeObject to_P_2 = new TreeObject("HMM Observations");
		TreeObject to_P_3 = new TreeObject("Monitoring Offline Prediction");
		TreeObject to_P_4 = new TreeObject(
				"Monitoring Offline Prediction Over Time");

		TreeParent p3 = new TreeParent("Predcition");

		p3.addChild(to_P_1);
		p3.addChild(to_P_2);
		p3.addChild(to_P_3);
		p3.addChild(to_P_4);

		// Prevention Section
		TreeObject to_R_1 = new TreeObject("Responses");
		TreeObject to_R_2 = new TreeObject("Response Criteria");
		TreeObject to_R_3 = new TreeObject("Response Criteria Weight");
		TreeObject to_R_4 = new TreeObject("Response Positive Value");
		TreeObject to_R_5 = new TreeObject("Response Negative Value");
		TreeObject to_R_6 = new TreeObject("Response Positive Value Level");
		TreeObject to_R_7 = new TreeObject("Response Negative Value Level");
		TreeObject to_R_8 = new TreeObject("Response Effectiveness");

		// TreeObject to15 = new TreeObject("Strategy");
		// TreeObject to16 = new TreeObject("Proactive Response");
		// TreeObject to17 = new TreeObject("Health-for-Host (H4H)");
		// TreeObject to18 = new TreeObject(
		// "Relationship between Response and Strategy");
		// TreeObject to19 = new TreeObject(
		// "Relationship between Response and H4H");
		// TreeObject to20 = new TreeObject(
		// "Relationship between Response and FSM");
		// TreeObject to21 = new TreeObject("Monitor Automated Responses");
		// TreeObject to22 = new TreeObject("Monitor Response Goodness");
		// TreeObject to23 = new TreeObject("Monitor Health of Network");
		// TreeObject to24 = new TreeObject("History of Contermeasure");
		// TreeObject to25 = new TreeObject("History of Attack");
		// TreeObject to26 = new TreeObject("History of Response Goodness");
		TreeParent p4 = new TreeParent("Response System");
		p4.addChild(to_R_1);
		p4.addChild(to_R_2);
		p4.addChild(to_R_3);
		p4.addChild(to_R_4);
		p4.addChild(to_R_5);
		p4.addChild(to_R_6);
		p4.addChild(to_R_7);
		p4.addChild(to_R_8);

		// Health Monitoring
		TreeObject to_HM_1 = new TreeObject("Health Monitoring");

		TreeParent p5 = new TreeParent("Health Monitoring");
		p5.addChild(to_HM_1);

		TreeParent p6 = new TreeParent("Report");

		TreeParent p7 = new TreeParent("Help");

		TreeParent root = new TreeParent("");
		root.addChild(p0);
		root.addChild(p1);
		root.addChild(p2);
		root.addChild(p3);
		root.addChild(p4);
		root.addChild(p5);
		root.addChild(p6);
		root.addChild(p7);

		return root;

	}

	/**
	 * This is a callback that will allow us to create the viewer and initialize
	 * it.
	 */
	public void createPartControl(final Composite parent) {
		static_parent = parent;
		viewer = new TreeViewer(parent, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL
				| SWT.BORDER);
		viewer.setContentProvider(new ViewContentProvider());
		viewer.setLabelProvider(new ViewLabelProvider());
		viewer.setInput(createDummyModel());
		viewer.addPostSelectionChangedListener(new ISelectionChangedListener() {

			@SuppressWarnings("restriction")
			@Override
			public void selectionChanged(SelectionChangedEvent event) {

				String data;
				data = event.getSelection().toString();

				if (event.getSelection().toString()
						.contains("[Decision Makers]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(DecisionMakersView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Criteria Linguistic Variables]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(CriteriaLinguisticVariablesView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Ratings Linguistic Variables]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(RatingsLinguisticVariablesView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Resource Criteria]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(ResourceCriteriaView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Resource Criteria Weight]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(ResourceCriteriaWeightView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString().contains("[Hosts]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage().showView(HostView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Resource Category]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage().showView(ResourceCatView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Resources]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage().showView(ResourceView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Host Resources]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage().showView(HostResourceView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Resource Value]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage().showView(ResourceValueView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Resource Ranking (TOPSIS)]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(ResourceRankingView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Resource Value Level (SAW)]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(ResourceValueLevelView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Vulnerability Criteria]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(VulnerabilityCriteriaView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Vulnerability Criteria Weight]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(VulnerabilityCriteriaWeightView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Vulnerability Effect]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(VulnerabilityEffectView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Vulnerability Ranking (TOPSIS)]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(VulnerabilityRankingView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Vulnerability Effect Level (SAW)]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(VulnerabilityEffectLevelView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString().contains("[Alert]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage().showView(AlertView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Alert Classification]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(AlertClassificationView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString().contains("[Generate]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage().showView(AttackGraphView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Alert Correlatiom Matrix1 (ACM1)]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(AlertCorrelation1View.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Alert Correlatiom Matrix2 (ACM2)]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(AlertCorrelation2View.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Monitoring Offline Alert Optimization]")) {
					try {
						PlatformUI
								.getWorkbench()
								.getActiveWorkbenchWindow()
								.getActivePage()
								.showView(
										MonitoringOfflineAlertOptimizationView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[HMM States]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage().showView(HMMStatesView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[HMM Observations]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(HMMObservationsView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Monitoring Offline Prediction]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(MonitoringOfflinePredictionView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Monitoring Offline Prediction Over Time]")) {
					try {
						PlatformUI
								.getWorkbench()
								.getActiveWorkbenchWindow()
								.getActivePage()
								.showView(
										MonitoringOfflinePredictionOverTimeView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Monitoring Offline Risk Index with Fuzzy]")) {
					try {
						PlatformUI
								.getWorkbench()
								.getActiveWorkbenchWindow()
								.getActivePage()
								.showView(
										MonitoringOfflineRiskIndexWithFuzzyView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Monitoring Offline Risk Index with HMM]")) {
					try {
						PlatformUI
								.getWorkbench()
								.getActiveWorkbenchWindow()
								.getActivePage()
								.showView(
										MonitoringOfflineRiskIndexWithHMMView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Health Monitoring]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage().showView(HealthView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event
						.getSelection()
						.toString()
						.contains(
								"[Relationship between Alert Classification and Resource]")) {
					try {
						PlatformUI
								.getWorkbench()
								.getActiveWorkbenchWindow()
								.getActivePage()
								.showView(
										RelationshipAlertClassificationANDResourceView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Response Criteria]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(ResponseCriteriaView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Response Criteria Weight]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(ResponseCriteriaWeightView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Responses]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage().showView(ResponseView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Response Positive Value]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(ResponsePositiveValueView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Response Negative Value]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(ResponseNegativeValueView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Response Positive Value Level]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(ResponsePositiveValueLevelView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Response Negative Value Level]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(ResponseNegativeValueLevelView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				} else if (event.getSelection().toString()
						.contains("[Response Effectiveness]")) {
					try {
						PlatformUI.getWorkbench().getActiveWorkbenchWindow()
								.getActivePage()
								.showView(ResponseEffectivenessView.ID);
					} catch (PartInitException e) {
						e.printStackTrace();
					}
				}
			}
		});

	}

	/**
	 * Passing the focus request to the viewer's control.
	 */
	public void setFocus() {
		viewer.getControl().setFocus();
	}
}
