package org.eclipse.linuxtools.lttng.SYSPRO.AttackGraph;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DecimalFormat;

import net.sourceforge.jFuzzyLogic.FIS;

import org.eclipse.core.runtime.Platform;
import org.eclipse.linuxtools.lttng.SYSPRO.ui.Application;
import org.eclipse.linuxtools.lttng.SYSPRO.ui.Connect;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.internal.util.BundleUtility;
import org.eclipse.zest.core.widgets.Graph;
import org.eclipse.zest.core.widgets.GraphNode;
import org.osgi.framework.Bundle;

import org.eclipse.zest.core.widgets.Graph;
import org.eclipse.zest.core.widgets.GraphConnection;
import org.eclipse.zest.core.widgets.GraphNode;
import org.eclipse.zest.core.widgets.ZestStyles;
import org.eclipse.zest.layouts.LayoutStyles;
import org.eclipse.zest.layouts.algorithms.SpringLayoutAlgorithm;
import org.eclipse.zest.layouts.algorithms.TreeLayoutAlgorithm;

public class DynamicAttackGraph {
	
	private Graph graph;
	GraphNode node0;
	GraphNode node1;
	GraphNode node2;
	GraphNode node3;
	GraphNode node4;
	GraphNode node5;
	GraphNode node6;
	GraphNode node7;
	GraphNode node8;
	GraphNode node9;


	public DynamicAttackGraph (Composite parent) {
		
		graph = new Graph(parent , SWT.NONE);
	}

	public void run(Composite parent, String s, String d) {
		if (s == "Apache" && d == "Apache shell") {
			
			node0 = new GraphNode(graph, SWT.NONE, "Start");
			node1 = new GraphNode(graph, SWT.NONE, "Apache");
			node2 = new GraphNode(graph, SWT.NONE, "Apache shell");

			new GraphConnection(graph, ZestStyles.CONNECTIONS_DIRECTED, node0, node1);
			new GraphConnection(graph, ZestStyles.CONNECTIONS_DIRECTED, node1, node2);

		}
		else if (s == "Apache shell" && d == "ncat") {
			node3 = new GraphNode(graph, SWT.NONE, "ncat");

			new GraphConnection(graph, ZestStyles.CONNECTIONS_DIRECTED, node2, node3);
		}
		else if (s == "ncat" && d == "wget") {
			node4 = new GraphNode(graph, SWT.NONE, "wget");

			GraphConnection graphConnection = new GraphConnection(graph, ZestStyles.CONNECTIONS_DIRECTED, node3, node4);
			
			graphConnection.changeLineColor(parent.getDisplay().getSystemColor(SWT.COLOR_GREEN));
		    graphConnection.setText("upload exploit");
		    graphConnection.setHighlightColor(parent.getDisplay().getSystemColor(SWT.COLOR_RED));
		}
		else if (s == "wget" && d == "ncat") {

			new GraphConnection(graph, ZestStyles.CONNECTIONS_DIRECTED, node4, node3);
			
		}
		else if (s == "ncat" && d == "compile") {
			node5 = new GraphNode(graph, SWT.NONE, "compile");

			GraphConnection graphConnection = new GraphConnection(graph, ZestStyles.CONNECTIONS_DIRECTED, node3, node5);
			graphConnection.changeLineColor(parent.getDisplay().getSystemColor(SWT.COLOR_GREEN));
		    graphConnection.setText("compile exploit");
		    graphConnection.setHighlightColor(parent.getDisplay().getSystemColor(SWT.COLOR_RED));
		}
		else if (s == "compile" && d == "ncat") {

			new GraphConnection(graph, ZestStyles.CONNECTIONS_DIRECTED, node5, node3);
		}
		else if (s == "ncat" && d == "exploit") {
			node6 = new GraphNode(graph, SWT.NONE, "exploit");

			GraphConnection graphConnection = new GraphConnection(graph, ZestStyles.CONNECTIONS_DIRECTED, node3, node6);
			graphConnection.changeLineColor(parent.getDisplay().getSystemColor(SWT.COLOR_GREEN));
		    graphConnection.setText("run exploit");
		    graphConnection.setHighlightColor(parent.getDisplay().getSystemColor(SWT.COLOR_RED));
		}
		else if (s == "exploit" && d == "exploit shell") {
			node7 = new GraphNode(graph, SWT.NONE, "exploit shell");

			new GraphConnection(graph, ZestStyles.CONNECTIONS_DIRECTED, node6, node7);
		}
		else if (s == "exploit shell" && d == "root permission") {
			node8 = new GraphNode(graph, SWT.NONE, "root permission");
			node9 = new GraphNode(graph, SWT.NONE, "end");

			GraphConnection graphConnection = new GraphConnection(graph, ZestStyles.CONNECTIONS_DIRECTED, node7, node8);
			graphConnection.changeLineColor(parent.getDisplay().getSystemColor(SWT.COLOR_GREEN));
		    graphConnection.setText("add user");
		    graphConnection.setHighlightColor(parent.getDisplay().getSystemColor(SWT.COLOR_RED));
			new GraphConnection(graph, ZestStyles.CONNECTIONS_DIRECTED, node8, node9);
		}
		
		graph.setLayoutAlgorithm(new SpringLayoutAlgorithm(LayoutStyles.NO_LAYOUT_NODE_RESIZING), true);
		
	}
		
}
