package org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DecimalFormat;

import org.eclipse.linuxtools.lttng.SYSPRO.ui.Connect;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.ui.part.ViewPart;


public class VulnerabilityEffectLevelView extends ViewPart {

	public static final String ID = "org.eclipse.ui.tutorials.rcp.part3.VulnerabilityEffectLevelView";
	int VC_No=0;

	public void createPartControl(Composite parent) {
		Composite top = new Composite(parent, SWT.NONE);
        DecimalFormat df = new  DecimalFormat ("0.##");

		GridLayout layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		top.setLayout(layout);
		// top banner
		Composite banner = new Composite(top, SWT.NONE);
		banner.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL, GridData.VERTICAL_ALIGN_BEGINNING, true, false));
		layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		layout.numColumns = 2;
		banner.setLayout(layout);

		// Create Toolbar
	    Image insert_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/insert_object.png");
	    Image edit_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/edit_object.png");
	    Image delete_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/delete_object.png");

	    
		ToolBar toolBar = new ToolBar (banner, SWT.FLAT | SWT.BORDER);
		ToolItem itemInsert = new ToolItem (toolBar, SWT.DROP_DOWN | SWT.PUSH);
		//itemInsert.setText("Insert");
		itemInsert.setImage(insert_icon);
		itemInsert.setToolTipText("Insert");
		ToolItem itemUpdate = new ToolItem (toolBar, SWT.PUSH);
		//itemUpdate.setText("Update");
		itemUpdate.setImage(edit_icon);
		itemUpdate.setToolTipText("Edit");
		ToolItem itemDelete = new ToolItem (toolBar, SWT.PUSH);
		//itemDelete.setText("Delete");
		itemDelete.setImage(delete_icon);
		itemDelete.setToolTipText("Delete");


		toolBar.pack (); 
		// The relative importance weights of the all criteria by all decision makers
		Label label_C = new Label(top, SWT.BORDER);
		label_C.setText("The relative importance weights of the all vulnerability criteria by all decision makers");
		Table t_CW = new Table(top, SWT.BORDER);
		
		// Set Column Header
		Connect c = new Connect();
		TableColumn tc1 = new TableColumn(t_CW, SWT.CENTER);
		tc1.setWidth(250);


		ResultSet rs = null;
		int i=1;
		int DM_No= 0;

		
		try {
			rs = c.Query("select * from DecisionMakers order by Id");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String NameVal = rs.getString ("Name");
				
				TableColumn tc = new TableColumn(t_CW, SWT.CENTER);
				tc.setText("D" + i +" = " + NameVal);
				tc.setWidth(250);
				i++;

			}
		} catch (SQLException e) {
			e.printStackTrace();
		}

		TableColumn tc2 = new TableColumn(t_CW, SWT.CENTER);
		tc2.setText("Deffuzification of combined weights");
		tc2.setWidth(250);
		
		t_CW.setHeaderVisible(true);
		
		// Fetch Data
		
		rs = null;
		DM_No= i-1;
		int count= 0;
		i = 1;
		int j = 0;
		double value1 = 0, value2 = 0, value3 = 0, D_Value = 0;
		
		String CheckName = ""; 
		
		try {
			rs = c.Query("select VulnerabilityCriteria.Name, DecisionMakers.Name, CriteriaLinguisticVariables.Name, " +
					"CriteriaLinguisticVariables.Value1, CriteriaLinguisticVariables.Value2, CriteriaLinguisticVariables.Value3 " +
					"from VulnerabilityCriteriaWeight, VulnerabilityCriteria, DecisionMakers, CriteriaLinguisticVariables where " +
					"VulnerabilityCriteriaWeight.VulnerabilityCriteria_Id = VulnerabilityCriteria.Id and VulnerabilityCriteriaWeight.DecisionMaker_Id = DecisionMakers.Id " +
					"and VulnerabilityCriteriaWeight.Linguistic_Variable_Id = CriteriaLinguisticVariables.Id " +
					"order by VulnerabilityCriteriaWeight.VulnerabilityCriteria_Id, VulnerabilityCriteriaWeight.DecisionMaker_Id ");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String CriteriaNameVal = rs.getString ("VulnerabilityCriteria.Name");
				String CriteriaLinguisticVariablesVal = rs.getString ("CriteriaLinguisticVariables.Name");
				
				
				
				if (!CheckName.equals(CriteriaNameVal)) {
					TableItem item1 = new TableItem(t_CW, SWT.NONE);
					item1.setText(new String[] { "C" + i +" = " + CriteriaNameVal,CriteriaLinguisticVariablesVal});
					i++;
					j = 2;
					CheckName = CriteriaNameVal;
					value1 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value1"));
					value2 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value2"));
					value3 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value3"));
					D_Value = (value1 + value2 * 2 + value3)/4;
					count++;

				}
				else {
					TableItem item1 = t_CW.getItem(i-2);
					if (count == (DM_No-1)) {
				        value1 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value1"));
						value2 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value2"));
						value3 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value3"));
						D_Value += (value1 + value2 * 2 + value3)/4;
						D_Value = D_Value/DM_No;
						item1.setText(j, CriteriaLinguisticVariablesVal);
						item1.setText(j+1, df.format(D_Value));
						count= 0;
					}
					else {
						item1.setText(j, CriteriaLinguisticVariablesVal);
						value1 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value1"));
						value2 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value2"));
						value3 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value3"));
						D_Value += (value1 + value2 * 2 + value3)/4;

						count++;
					}
					j++;
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		t_CW.pack();

		// Set the number of Vulnerability criteria
		VC_No= 2; 
		// The ratings of the all vulnerabilities by decision makers under all criteria
		Label label_RV = new Label(top, SWT.BORDER);
		label_RV.setText("The ratings of the all vulnerabilities by decision makers under all criteria");
		Table t_R_DM = new Table(top, SWT.BORDER);
		
		// Set Column Header
		TableColumn tc1_RV = new TableColumn(t_R_DM, SWT.CENTER);
		TableColumn tc2_RV = new TableColumn(t_R_DM, SWT.CENTER);
		
		tc1_RV.setText("Vulnerability Criteria");
		tc2_RV.setText("Resource Name");

		tc1_RV.setWidth(200);
		tc2_RV.setWidth(200);


		rs = null;
		i=1;
		DM_No= 0;
		
		try {
			rs = c.Query("select * from DecisionMakers order by Id");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String NameVal = rs.getString ("Name");
				
				TableColumn tc = new TableColumn(t_R_DM, SWT.CENTER);
				tc.setText("D" + i +" = " + NameVal);
				tc.setWidth(200);
				i++;

			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		TableColumn tc3_RV = new TableColumn(t_R_DM, SWT.CENTER);
		tc3_RV.setText("Aggregated fuzzy number");
		tc3_RV.setWidth(250);
		
		t_R_DM.setHeaderVisible(true);

		// Fetch Data
		
		rs = null;
		DM_No= i-1;
		count= 0;

		i = 1;
		int ItemNo= 1;
		j = 0;
		CheckName = ""; 
		value1 = 0;
		value2 = 0;
		value3 = 0;

		
		try {
			rs = c.Query("select VulnerabilityCriteria.Name as 'Vulnerability Criteria Name', Resource.Name as 'Resource Name', RatingsLinguisticVariables.Name as 'Value' " +
					", RatingsLinguisticVariables.Value1, RatingsLinguisticVariables.Value2, RatingsLinguisticVariables.Value3 " +
					"from VulnerabilityEffect, Resource, DecisionMakers, VulnerabilityCriteria, RatingsLinguisticVariables " +
					"where VulnerabilityEffect.DecisionMaker_Id = DecisionMakers.Id " +
					"and VulnerabilityEffect.Resource_Id = Resource.Id " +
					"and VulnerabilityEffect.VulnerabilityCriteria_Id = VulnerabilityCriteria.Id " +
					"and VulnerabilityEffect.Linguistic_Variable_Id = RatingsLinguisticVariables.Id " +
					"order by Resource.Id, VulnerabilityCriteria.Id, DecisionMakers.Id");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String CriteriaNameVal = rs.getString ("Vulnerability Criteria Name");
				String ResourceNameVal = rs.getString ("Resource Name");
				String ValueVal = rs.getString ("Value");

				if (!CheckName.equals(CriteriaNameVal)) {
					TableItem item1 = new TableItem(t_R_DM, SWT.NONE);
					if (i == (VC_No+1)) i= 1;
					item1.setText(new String[] { "C" + i +" = " + CriteriaNameVal, ResourceNameVal, ValueVal});
					i++;
					ItemNo++;
					j = 3;
					CheckName = CriteriaNameVal;
					value1 = Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value1"));
					value2 = Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value2"));
					value3 = Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value3"));
					count++;
				}
				else {
					TableItem item1 = t_R_DM.getItem(ItemNo-2);
				
					if (count == (DM_No-1)) {
				        value1 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value1"));
						value2 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value2"));
						value3 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value3"));
						value1 = value1/DM_No;
						value2 = value2/DM_No;
						value3 = value3/DM_No;
						item1.setText(j, ValueVal);
						item1.setText(j+1, "(" + df.format(value1) + ", " + df.format(value2) + ", " + df.format(value3) + ")");
						count= 0;
					}
					else {
						item1.setText(j, ValueVal);
						value1 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value1"));
						value2 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value2"));
						value3 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value3"));
						count++;
					}
					j++;
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		t_R_DM.pack();
		
		// The fuzzy weighted normalized decision matrix
		Label label_FWN_DM = new Label(top, SWT.BORDER);
		label_FWN_DM.setText("The fuzzy weighted normalized decision matrix");
		final Table t1 = new Table(top, SWT.BORDER);
		
		TableColumn tc4 = new TableColumn(t1, SWT.CENTER);
		tc4.setWidth(250);

		rs = null;
		i=1;
		
		try {
			rs = c.Query("select * from VulnerabilityCriteria order by Id");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String NameVal = rs.getString ("Name");
				
				TableColumn tc = new TableColumn(t1, SWT.CENTER);
				tc.setText("C" + i +" = " + NameVal);
				tc.setWidth(250);
				i++;

			}
		} catch (SQLException e) {
			e.printStackTrace();
		}

		TableColumn item_DV_TC = new TableColumn(t1, SWT.CENTER);
		item_DV_TC.setText("Def. values TC");
		item_DV_TC.setWidth(150);

		TableColumn item_CS = new TableColumn(t1, SWT.CENTER);
		item_CS.setText("Def. values CS");
		item_CS.setWidth(150);
		
		TableColumn item_R = new TableColumn(t1, SWT.CENTER);
		item_R.setText("Result");
		item_R.setWidth(150);

	
		// 
		int criteria;
		int k;
		Double ThirdValue = 0.0;
		TableItem  criteria_Item;
		TableItem  resource_criteria_Item;
		String  criteria_name, criteria_value;
		int counter;
		for (criteria = 0; criteria < t_CW.getItemCount(); criteria++) {
			
			criteria_Item = t_CW.getItem(criteria);
			criteria_name = criteria_Item.getText(0);
			criteria_value = criteria_Item.getText(4);
			counter = 0;
			Double max = 0.0;

			for (k = 0; k < t_R_DM.getItemCount(); k++) {
				resource_criteria_Item = t_R_DM.getItem(k);
				if (resource_criteria_Item.getText(0).contains(criteria_name)) {
					ThirdValue = getFuzzyValue(resource_criteria_Item.getText(5),3);
					if (ThirdValue > max) max = ThirdValue;
				}
			}
			
			for (k = 0; k < t_R_DM.getItemCount(); k++) {
				resource_criteria_Item = t_R_DM.getItem(k);
				if (resource_criteria_Item.getText(0).contains(criteria_name)) {
					if (criteria == 0 ) {
						// create row
						TableItem item1 = new TableItem(t1, SWT.NONE);
						
						value1 = (getFuzzyValue(resource_criteria_Item.getText(5),1)/max) * Double.parseDouble(criteria_value);
						value2 = (getFuzzyValue(resource_criteria_Item.getText(5),2)/max) * Double.parseDouble(criteria_value);
						value3 = (getFuzzyValue(resource_criteria_Item.getText(5),3)/max) * Double.parseDouble(criteria_value);
						
						item1.setText(new String[] { resource_criteria_Item.getText(1),  "(" + df.format(value1) + ", " + df.format(value2) + ", " + df.format(value3) + ")"});
					} else {
						value1 = (getFuzzyValue(resource_criteria_Item.getText(5),1)/max) * Double.parseDouble(criteria_value);
						value2 = (getFuzzyValue(resource_criteria_Item.getText(5),2)/max) * Double.parseDouble(criteria_value);
						value3 = (getFuzzyValue(resource_criteria_Item.getText(5),3)/max) * Double.parseDouble(criteria_value);
						TableItem item1 = t1.getItem(counter);
						counter++;
						item1.setText(criteria + 1, "(" + df.format(value1) + ", " + df.format(value2) + ", " + df.format(value3) + ")");
					}
				}
			}

		}
		
		
		t1.setHeaderVisible(true);
		t1.pack();
		
		
		// Calculate Effect level
		TableItem  resource_Item;

		double DNmuber_TC;
		double DNmuber_CS;

		
		for (int r = 0; r < t1.getItemCount(); r++) {
			resource_Item = t1.getItem(r);
					
			k= t_CW.getItemCount();
			
			value1 = getFuzzyValue(resource_Item.getText(1),1);
			value2 = getFuzzyValue(resource_Item.getText(1),2);
			value3 = getFuzzyValue(resource_Item.getText(1),3);
			
			DNmuber_TC = (value1 + value2 * 2 + value3)/4;
			
			value1 = getFuzzyValue(resource_Item.getText(2),1);
			value2 = getFuzzyValue(resource_Item.getText(2),2);
			value3 = getFuzzyValue(resource_Item.getText(2),3);
			
			DNmuber_CS = (value1 + value2 * 2 + value3)/4;

			
			resource_Item.setText(k + 1, df.format(DNmuber_TC));
			resource_Item.setText(k + 2, df.format(DNmuber_CS));
			resource_Item.setText(k + 3, df.format(DNmuber_TC/DNmuber_CS));

		}
		
	    // Store results in Database
		final Button btn_store = new Button(top, SWT.PUSH);
		btn_store.setBounds(40, 50, 50, 20);
		btn_store.setText("Store Results");
		btn_store.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent e) {
				String IdVal = null;
				
				TableItem  resource_Item;
				
				// delete previous calculation
				Connect c_delete = new Connect();
				try {
					c_delete.Insert("delete from VulnerabilityEffectLevel");
				} catch (SQLException e2) {
					e2.printStackTrace();
				}
				
				for (int r = 0; r < t1.getItemCount(); r++) {
					Connect c = new Connect();
					ResultSet rs = null;

					resource_Item = t1.getItem(r);
					// get resource id
					try {
						rs = c.Query("select * from Resource where name='"+ resource_Item.getText(0) + "'");
					} catch (SQLException e1) {
						e1.printStackTrace();
					}
					try {
						while (rs.next ())
						{
							IdVal = rs.getString ("Id");
						}
					} catch (SQLException e1) {
						e1.printStackTrace();
					}
					// insert
					try {
						c.Insert("insert into VulnerabilityEffectLevel values(" + IdVal +"," + resource_Item.getText(VC_No+3) + ")");
					} catch (SQLException e1) {
						e1.printStackTrace();
					}
				}	
			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				
			}
		 });
	}

	public Double getFuzzyValue(String str, int index) {
		int frs_ch, trd_ch;
		
		

		if (index == 1) {
			
			frs_ch = str.indexOf(",");
			return Double.parseDouble(str.substring(1, frs_ch)); 
			
		} else if (index == 2) {
			
			str = str.replaceFirst(",", "-");
			frs_ch = str.indexOf("-");
			trd_ch = str.indexOf(",");
			return Double.parseDouble(str.substring(frs_ch + 1, trd_ch));
			
		} else {
			
			str = str.replaceFirst(",", "-");
			frs_ch = str.indexOf(",");
			trd_ch = str.indexOf(")");
			return Double.parseDouble(str.substring(frs_ch + 1, trd_ch)); 

		}
			
	}
	public void setFocus() {
	}
}
